#----------------------------
# Table structure for T_CHAR_VALUE
#----------------------------
drop table if exists T_CHAR_VALUE;
create table T_CHAR_VALUE (
   CHARACTERISTIC_ID int(11) not null default '0',
   VALUE int(11) not null default '0',
   DESCRIPTION varchar(255) not null,
   primary key (CHARACTERISTIC_ID, VALUE))
   type=MyISAM;
#----------------------------
# Table structure for T_CHARACTERISTIC
#----------------------------
drop table if exists T_CHARACTERISTIC;
create table T_CHARACTERISTIC (
   CHARACTERISTIC_ID int(11) not null auto_increment,
   NAME varchar(255) not null,
   DESCRIPTION varchar(255) not null,
   GROUP_ID int(11) not null default '0',
   primary key (CHARACTERISTIC_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_DEPENDENCIES
#----------------------------
drop table if exists T_DEPENDENCIES;
create table T_DEPENDENCIES (
   ROLE_ID int(11) not null default '0',
   TASK_ID int(11) not null default '0',
   primary key (TASK_ID, ROLE_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_GROUP
#----------------------------
drop table if exists T_GROUP;
create table T_GROUP (
   GROUP_ID int(11) not null auto_increment,
   NAME varchar(255) not null,
   DESCRIPTION varchar(255) not null,
   primary key (GROUP_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_INDICATOR
#----------------------------
drop table if exists T_INDICATOR;
create table T_INDICATOR (
   INDICATOR_ID int(11) not null auto_increment,
   NAME varchar(255) not null,
   DESCRIPTION blob not null,
   primary key (INDICATOR_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_INVOLVEMENT
#----------------------------
drop table if exists T_INVOLVEMENT;
create table T_INVOLVEMENT (
   KEY_CHARACTERISTIC char(1) not null,
   CHARACTERISTIC_ID int(11) not null default '0',
   INDICATOR_ID int(11) not null default '0',
   primary key (INDICATOR_ID, CHARACTERISTIC_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_ROLE
#----------------------------
drop table if exists T_ROLE;
create table T_ROLE (
   ROLE_ID int(11) not null auto_increment,
   NAME varchar(100) not null,
   SCENARIO_ID int(11) not null default '0',
   primary key (ROLE_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_RULE
#----------------------------
drop table if exists T_RULE;
create table T_RULE (
  RULEFRAGMENT_ID int(11) NOT NULL auto_increment,
  RULE_ID int(11) NOT NULL default '0',
  RELATION varchar(255) NOT NULL default '',
  CHARACTERISTIC varchar(255) NOT NULL default '',
  WARNING varchar(255) default NULL,
  NAME varchar(255) default NULL,
  VALUE int(11) NOT NULL default '0',
  OPERATOR varchar(255) NOT NULL default '',
  CHARACTERISTIC_ID int(11) NOT NULL default '0',
  primary key  (RULEFRAGMENT_ID))
  type=MyISAM;

#----------------------------
# Table structure for T_SCENARIO
#----------------------------
drop table if exists T_SCENARIO;
create table T_SCENARIO (
   SCENARIO_ID int(11) not null auto_increment,
   NAME varchar(100) not null,
   DESCRIPTION varchar(255),
   USER_ID int(11) not null default '0',
   primary key (SCENARIO_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_TASK
#----------------------------
drop table if exists T_TASK;
create table T_TASK (
   TASK_ID int(11) not null auto_increment,
   NAME varchar(255) not null,
   DESCRIPTION varchar(255),
   PRE_LOCATION varchar(255),
   PRE_RESOURCES varchar(255),
   POST_LOCATION varchar(255),
   POST_RESOURCES varchar(255),
   ROLE_ID int(11),
   COMPOSITE char(3),
   WEIGHT int(11) default '0',
   primary key (TASK_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_TASK_CHAR
#----------------------------
drop table if exists T_TASK_CHAR;
create table T_TASK_CHAR (
   TASK_ID int(11) not null default '0',
   CHARACTERISTIC_ID int(11) not null default '0',
   VALUE int(11) not null default '0',
   primary key (TASK_ID, CHARACTERISTIC_ID, VALUE))
   type=MyISAM;
#----------------------------
# Table structure for T_TASK_DEPENDENCY
#----------------------------
drop table if exists T_TASK_DEPENDENCY;
create table T_TASK_DEPENDENCY (
   TASK_ID int(11) not null default '0',
   DEPENDENT_TASK_ID int(11) not null default '0',
   CONDITION_TYPE varchar(20) not null,
   primary key (TASK_ID, DEPENDENT_TASK_ID))
   type=MyISAM;
#----------------------------
# Table structure for T_USER
#----------------------------
drop table if exists T_USER;
create table T_USER (
   USER_ID int(11) not null auto_increment,
   EMAIL varchar(50) not null,
   `PASSWORD` varchar(20) not null,
   NAME varchar(100),
   ACCESSLEVEL char(1) not null,
   primary key (USER_ID))
   type=MyISAM;
#-----------------------------------------
# Create an administrator of the MWCF site
# Insert the characteristics, rules and indicators
#-----------------------------------------

INSERT INTO t_char_value (CHARACTERISTIC_ID,VALUE,DESCRIPTION) VALUES 
 (1,1,'No'),
 (1,3,'Uncertain'),
 (1,5,'Yes'),
 (2,1,'No'),
 (2,3,'Partial'),
 (2,5,'Yes'),
 (3,1,'Planned'),
 (3,3,'Partial'),
 (3,5,'Adhoc'), 
 (4,3,'After task'),
 (4,1,'No'),
 (4,5,'Within task'),
 (5,1,'None'),
 (5,3,'Once'),
 (5,5,'Many'),
 (6,5,'Video'),
 (6,4,'Audio'),
 (6,3,'Graphics'),
 (6,2,'Text'),
 (6,1,'NA'),
 (7,1,'NA'),
 (7,3,'Discrete'),
 (7,5,'Continuous'),
 (8,1,'NA'),
 (8,2,'Low'),
 (8,3,'Medium'),
 (8,4,'High'),
 (8,5,'Real-time'),
 (9,1,'NA'),
 (9,2,'Slow'),
 (9,3,'Medium'),
 (9,4,'High'),
 (9,5,'Real-time'),
 (10,1,'NA'),
 (10,2,'Slow'),
 (10,3,'Medium'),
 (10,4,'Fast'),
 (10,5,'Very fast'),
 (11,1,'No'),
 (11,3,'Partial'),
 (11,5,'Yes'),
 (12,1,'No'),
 (12,3,'Partial'),
 (12,5,'Yes'),
 (13,1,'No'),
 (13,3,'Partial'),
 (13,5,'Yes'),
 (14,1,'No'),
 (14,3,'Partial'),
 (14,5,'Yes'),
 (15,1,'No'),
 (15,3,'Partial'),
 (15,5,'Yes'),
 (16,5,'Yes'),
 (16,3,'Partial'),
 (16,1,'No'),
 (17,1,'No'),
 (17,3,'Partial');
INSERT INTO t_char_value (CHARACTERISTIC_ID,VALUE,DESCRIPTION) VALUES 
 (17,5,'Yes'),
 (18,1,'No'),
 (18,3,'Partial'),
 (18,5,'Yes'),
 (19,1,'No'),
 (19,3,'Partial'),
 (19,5,'Yes'),
 (20,1,'Seconds'),
 (20,2,'Minutes'),
 (20,3,'Hours'),
 (20,4,'Days'),
 (20,5,'Weeks');


INSERT INTO t_characteristic (CHARACTERISTIC_ID,NAME,DESCRIPTION,GROUP_ID) VALUES 
 (1,'G1 Decomposable','Decides whether the task is composed of subtasks or\r\nnot.',1),
 (2,'G2 Part of sequence','Specifies if a task has order dependencies with respect\r\nto other tasks.',1),
 (3,'G3 Pre-planned','Describes to what degree a task is planned on beforhand',1),
 (4,'G4 Data synchronisation','Specifies when a task has to synchronise/ merge updated\r\ndata with other tasks.',1),
 (5,'G5 Data exchange rate','Specifies the rate of data exchange between the current\r\ntask and other tasks (during its lifetime).',1),
 (6,'I1 Information contents','Describes the complexity of the information required\r\nor produced by the task.',2),
 (7,'I2 Information streaming','Describes whether the task requires streaming of data\r\nor not.',2),
 (8,'I3 Information required related to time','Describes how important the information required to\r\nexecute the task is related to time.',2),
 (9,'I4 Information produced related to time','Describes how important the information produced by\r\nthe task is related to time.',2),
 (10,'I5 Information transmission speed','Describing the expected transmission speed of information\r\nused or produced by the task.',2);
INSERT INTO t_characteristic (CHARACTERISTIC_ID,NAME,DESCRIPTION,GROUP_ID) VALUES 
 (11,'L1 Location dependent','Describes to what degree a task must be executed at\r\na specific location (e.g. that a lecturer must be in a\r\nclassroom to teach students).',3),
 (12,'L2 Require services at location','Specifies if a task needs electronic services available\r\nat the location such as printers, network connections,\r\nvideo projectors, fax machines, etc.',3),
 (13,'L3 Produce services at location','Specifies if a task produces electronic services at the\r\nlocation that can be used by others at this location,\r\nsuch as information queries, beaming of information,\r\nnetwork connectivity etc.',3),
 (14,'L4 Location report','Specifies if a task must report its location to the system.',3),
 (15,'L5 Route constraints','Specifies if a mobile task must follow a specific route\r\nor not when moving around.',3),
 (16,'T1 Event-triggered','Decides whether a task is triggered by an event or not.',4),
 (17,'T2 Time constraint','Describes if a task must be executed at a specific time\r\nor within a specific time-span (e.g. a task must be performed between 10:15 and 12:00).',4);
INSERT INTO t_characteristic (CHARACTERISTIC_ID,NAME,DESCRIPTION,GROUP_ID) VALUES 
 (18,'T3 Temporal coordination','Describes if a task must be coordinated with other tasks\r\n(e.g. different military units must strike a the same time).',4),
 (19,'T4 Task resumption','Describes if a task can halt, and then later resume from\r\nwhere it left off (not requiring a complete restart of task).',4),
 (20,'T5 Task lifetime','Describes the expected lifetime of a task.',4);

INSERT INTO t_group (GROUP_ID,NAME,DESCRIPTION) VALUES 
 (1,'General','general'),
 (2,'Information','Info'),
 (3,'Location','Location'),
 (4,'Time','time');

INSERT INTO t_indicator (INDICATOR_ID,NAME,DESCRIPTION) VALUES 
 (1,'General Task Indivcator',0x475449),
 (2,'Information Complexity Indicator',0x494349),
 (3,'Location Complexity Indicator',0x4C4349),
 (4,'Time Complexity Indicator',0x544349),
 (5,'Network Connectivity Indicator',0x4E4349),
 (6,'Network Speed Indicator',0x4E5349),
 (7,'Energy Consumption Indicator',0x454349),
 (8,'Transactional Support Indicator',0x545349),
 (9,'Mobility Indicator',0x4D49);

INSERT INTO t_involvement (KEY_CHARACTERISTIC,CHARACTERISTIC_ID,INDICATOR_ID) VALUES 
 ('y',1,1),
 ('y',2,1),
 ('y',3,1),
 ('y',4,1),
 ('y',5,1),
 ('y',6,2),
 ('y',7,2),
 ('y',8,2),
 ('y',9,2),
 ('y',10,2),
 ('y',11,3),
 ('y',12,3),
 ('y',13,3),
 ('y',14,3),
 ('y',15,3),
 ('y',16,4),
 ('y',17,4),
 ('y',18,4),
 ('y',19,4),
 ('y',20,4),
 ('y',3,5),
 ('y',4,5),
 ('y',5,5),
 ('y',14,5),
 ('y',16,5),
 ('n',19,5),
 ('y',8,6),
 ('y',9,6),
 ('y',10,6),
 ('n',5,6),
 ('n',7,6),
 ('y',11,7),
 ('y',12,7),
 ('y',13,7),
 ('y',20,7),
 ('n',5,7),
 ('n',6,7),
 ('n',7,7),
 ('n',14,7),
 ('y',3,8),
 ('y',4,8),
 ('y',5,8),
 ('y',16,8),
 ('y',19,8),
 ('y',20,8),
 ('y',14,9),
 ('y',15,9),
 ('n',11,9),
 ('n',13,9),
 ('n',18,9);

INSERT INTO `T_RULE` VALUES (1, 0, 'or', 'I3 Information required related to time', 'If there is a high score on either (or both) of the characteristics I3 or I4, the information required to execute the task related to time or the information produced by the task related to time is highly important. This implies that there is a need for h', 'Rule 1', 4, 'ge', 8);
INSERT INTO `T_RULE` VALUES (2, 0, 'then', 'I4 Information produced related to time', 'If there is a high score on either (or both) of the characteristics I3 or I4, the information required to execute the task related to time or the information produced by the task related to time is highly important. This implies that there is a need for h', 'Rule 1', 4, 'ge', 9);
INSERT INTO `T_RULE` VALUES (3, 0, 'end', 'I5 Information transmission speed', 'If there is a high score on either (or both) of the characteristics I3 or I4, the information required to execute the task related to time or the information produced by the task related to time is highly important. This implies that there is a need for h', 'Rule 1', 4, 'ge', 10);
INSERT INTO `T_RULE` VALUES (4, 0, 'then', 'L5 Route constraints', 'If a task needs to follow a specific route when moving around (score 5 (yes) on L5), it is dependent on being at specific locations to execute the task, which implies a value of 5 (yes) on L1.', 'Rule 2', 5, 'eq', 15);
INSERT INTO `T_RULE` VALUES (5, 0, 'end', 'L1 Location dependent', 'If a task needs to follow a specific route when moving around (score 5 (yes) on L5), it is dependent on being at specific locations to execute the task, which implies a value of 5 (yes) on L1.', 'Rule 2', 5, 'eq', 11);
INSERT INTO `T_RULE` VALUES (6, 0, 'then', 'L4 Location report', 'A task that has a score of 5 on L4, which means that the task must report its location to the system, implies that the task is dependent on being at a specific location (since that location is of importance to the system).', 'Rule 3', 5, 'eq', 14);
INSERT INTO `T_RULE` VALUES (7, 0, 'end', 'L1 Location dependent', 'A task that has a score of 5 on L4, which means that the task must report its location to the system, implies that the task is dependent on being at a specific location (since that location is of importance to the system).', 'Rule 3', 5, 'eq', 11);
INSERT INTO `T_RULE` VALUES (8, 0, 'then', 'T3 Temporal coordination', 'If a task must be coordinated with other tasks with respect to time (score 5 (yes) on T3), a task is part of a sequence of tasks (score 5 on G2).', 'Rule 4', 5, 'eq', 18);
INSERT INTO `T_RULE` VALUES (9, 0, 'end', 'G2 Part of sequence', 'If a task must be coordinated with other tasks with respect to time (score 5 (yes) on T3), a task is part of a sequence of tasks (score 5 on G2).', 'Rule 4', 5, 'eq', 2);
INSERT INTO `T_RULE` VALUES (10, 0, 'then', 'I2 Information streaming', 'If a task requires streaming (score 5 on I2), it requires a high rate of data exchange between the current task and other tasks during its lifetime (score 5 - Many on G5).', 'Rule 5', 5, 'eq', 7);
INSERT INTO `T_RULE` VALUES (11, 0, 'end', 'G5 Data exchange rate', 'If a task requires streaming (score 5 on I2), it requires a high rate of data exchange between the current task and other tasks during its lifetime (score 5 - Many on G5).', 'Rule 5', 5, 'eq', 5);
INSERT INTO `T_RULE` VALUES (12, 0, 'then', 'G3 Pre-planned', 'If a task is Ad-hoc (score 5 on G3), then it is event-triggered (score 5 on T1). Ad-hoc tasks are activities that cannot be planned for and typically occurs as a reaction to some event.', 'Rule 6', 5, 'eq', 3);
INSERT INTO `T_RULE` VALUES (13, 0, 'end', 'T1 Event-triggered', 'If a task is Ad-hoc (score 5 on G3), then it is event-triggered (score 5 on T1). Ad-hoc tasks are activities that cannot be planned for and typically occurs as a reaction to some event.', 'Rule 6', 5, 'eq', 16);
INSERT INTO `T_RULE` VALUES (14, 0, 'then', 'T2 Time constraint', 'If a task has time constraints and must be executed at a specific time (score 5 on T2), it must be planned for (score 1 on G3).', 'Rule 7', 5, 'eq', 17);
INSERT INTO `T_RULE` VALUES (15, 0, 'end', 'G3 Pre-planned', 'If a task has time constraints and must be executed at a specific time (score 5 on T2), it must be planned for (score 1 on G3).', 'Rule 7', 1, 'eq', 3);
INSERT INTO `T_RULE` VALUES (16, 0, 'then', 'G2 Part of sequence', 'If a task is part of a sequence (score 5 on G2), it has to be planned for in advance (score 1 on G3).', 'Rule 8', 5, 'eq', 2);
INSERT INTO `T_RULE` VALUES (17, 0, 'end', 'G3 Pre-planned', 'If a task is part of a sequence (score 5 on G2), it has to be planned for in advance (score 1 on G3).', 'Rule 8', 1, 'eq', 3);
INSERT INTO `T_RULE` VALUES (18, 0, 'then', 'L5 Route constraints', 'If a task has a route constraint (score 5 on L5), it has to be planned for in advance (score 1 on G3).', 'Rule 9', 5, 'eq', 15);
INSERT INTO `T_RULE` VALUES (19, 0, 'end', 'G3 Pre-planned', 'If a task has a route constraint (score 5 on L5), it has to be planned for in advance (score 1 on G3).', 'Rule 9', 1, 'eq', 3);
INSERT INTO `T_RULE` VALUES (20, 0, 'then', 'T4 Task resumption', 'If a task can halt and later resume from where it left off (score 5 on T4), it must have a lifetime that can at least be measured in minutes (score 2 or more on T5).', 'Rule 10', 5, 'eq', 19);
INSERT INTO `T_RULE` VALUES (21, 0, 'end', 'T5 Task lifetime', 'If a task can halt and later resume from where it left off (score 5 on T4), it must have a lifetime that can at least be measured in minutes (score 2 or more on T5).', 'Rule 10', 2, 'ge', 20);


INSERT INTO t_user (USER_ID,EMAIL,PASSWORD,NAME,ACCESSLEVEL) VALUES 
 (1,'admin@mwcf.com','admin','MWCF Admin','a');


