package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.IndicatorBean;
import com.mowahs.mwcf.framework.GroupBean;
import com.mowahs.mwcf.framework.UserBean;
import com.mowahs.mwcf.site.forms.*;
import java.io.IOException;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class AddIndicatorAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
		
		HttpSession session = request.getSession();
		UserBean user = (UserBean) session.getAttribute("user");
		ActionErrors errors = new ActionErrors();
		if(user == null) {
			try {
				session.invalidate();
				return mapping. findForward("not_logged_in");
			} catch (java.lang.IllegalStateException e) {
				//do nothing
			}	
			return mapping.findForward("not_logged_in");
		} else {
			if(!user.getAccessLevel().equals("a")) {
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
				saveErrors(request, errors);
				return mapping.findForward("not_logged_in");
			}
		}
		
		IndicatorForm aform = (IndicatorForm) form;
		String submit = aform.getSubmit();
		String step = aform.getCurrentStep();
		String returnString	= "failure";
		
		if(submit != null) {
		
			if(submit.equals("Cancel")) {
				session.removeAttribute("indicator");
				returnString = "cancel";
				
			} else if (submit.equals("Back")) {
				if(step.equals("1") || step.equals("2")) {
					IndicatorBean indi = (IndicatorBean)session.getAttribute("indicator");
					aform.setCurrentStep("1");
					if(indi != null) {
						aform.setName(indi.getName());
						aform.setDescription(indi.getDescription());
					}
				}
				else if(step.equals("3"))
					aform.setCurrentStep("2");
			
				returnString = "next";
			
			} else if(submit.equals("Next")) {
				
				if(step.equals("1")) {
					IndicatorBean indi = (IndicatorBean)session.getAttribute("indicator");
					if(indi == null)
						indi = new IndicatorBean();
					indi.setName(aform.getName());
					indi.setDescription(aform.getDescription());
					aform.setCurrentStep("2");
					
				} else if (step.equals("2")) {
					int[] prime = aform.getPrimary();
				
					if(prime == null || prime.length == 0)
						errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("key.characteristics.required"));
					else {
						IndicatorBean indi = (IndicatorBean)session.getAttribute("indicator");
						indi.setPrimaryContent(prime);
						aform.setCurrentStep("3");
					}
					
				} else 
					aform.setCurrentStep("3");
					
				returnString = "next";
			
			} else if(submit.equals("Save indicator")) {
				int[] secondary = aform.getSecondary();
										
				IndicatorBean indi = (IndicatorBean) session.getAttribute("indicator");
				indi.setSecondaryContent(secondary);
				
				Connection conn = null;
				try {
					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
   					conn = dataSource.getConnection();
					
					if(indi.isNameUnique(conn, errors, indi.getName())) {
							
						int id = indi.saveIndicatorInDB(conn, errors);
						if (id == -1) {
							errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
							returnString = "failure";
						}
						returnString = "added";
					} else {
						errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("indicator.name.exists"));				
						returnString = "failure";
					}
					
    			} catch(Exception sqle) {
	   				servlet.log("Connection.process", sqle);
    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
				} finally {
					if(conn != null){
						try {
							conn.close();
						} catch (SQLException e){
			    			servlet.log("Connection.close", e);
		    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
		    			}
		    		}					
				}
				
			}
    	} else {
    		
    		GroupBean agroup = (GroupBean)session.getAttribute("group");
    		if(agroup == null)
    			agroup = new GroupBean();
    		Connection conn = null;
    		try {
				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
   				conn = dataSource.getConnection();
   				
    			agroup.getAllGroupsFromDB(conn, errors);
    			
    		} catch(Exception sqle) {
	   			servlet.log("Connection.process", sqle);
    			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
	    				servlet.log("Connection.close", e);
	    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    			}
	    		}					
			}		
    			
    		if(errors.empty()) {
    			session.setAttribute("group", agroup);
    			aform.setCurrentStep("1");
    			returnString = "next";
    		}	
    	}
    	saveErrors(request, errors);
    	return mapping.findForward(returnString);
    }
}
