package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.GroupBean;
import com.mowahs.mwcf.framework.CharacteristicBean;
import com.mowahs.mwcf.framework.UserBean;
import java.io.IOException;
import java.util.Vector;
import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class AddNewCharacteristicAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			
			UserBean user = (UserBean) session.getAttribute("user");
			GroupBean agroup = (GroupBean) session.getAttribute("group");
			AddNewCharacteristicForm aform = (AddNewCharacteristicForm) form;
			String returnString = "failure";
			
			if(user == null  || agroup == null) {
				try {
					session.invalidate();
				} catch (java.lang.IllegalStateException e) {
					//do.nothing
				} finally {
					returnString = "not_logged_in";	
				}
				return mapping.findForward("not_logged_in");
			} else if(!user.getAccessLevel().equals("a")) {
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
				saveErrors(request, errors);
				return mapping.findForward("not_logged_in");
			}
			else if(aform.getSubmit() != null && aform.getSubmit().equals("Cancel")) {
				session.removeAttribute("characteristic");
				session.removeAttribute("addNewCharacteristicForm");
				returnString = "cancel";
			}	
			else if(request.getParameter("groupId") != null) {
				int groupID = (new Integer(request.getParameter("groupId"))).intValue();
				if(groupID != agroup.getGroupID()) {
					Vector groups = agroup.getGroups();
					if(groups.size() > 0) {
						int i = 0;
						while(((GroupBean)groups.elementAt(i)).getGroupID() != groupID)
							i++;
						agroup = (GroupBean)groups.elementAt(i);
						agroup.setGroups(groups);
						session.setAttribute("group", agroup);
						returnString = "success";
					} else 
						returnString = "failure";
				} else 
					returnString = "success";
			} else if(request.getParameter("elementNo") != null) {
				int element = (new Integer(request.getParameter("elementNo"))).intValue();
				Vector scale = aform.getScale();
				scale.removeElementAt(element);
				scale.removeElementAt(element);
				aform.setScale(scale);
				return mapping.findForward("removed_scale_element");	
			}
								
			else if(aform.getSubmit() != null && aform.getSubmit().equals("Add value to scale")) {
				
				aform.addToScale(new Integer(aform.getValue()));
				aform.addToScale(aform.getValueDescription());
				returnString = "added_scale_element";
			}
			else if(aform.getSubmit() != null && aform.getSubmit().equals("Save characteristic")) {
				int groupID = agroup.getGroupID();
				Vector characs = agroup.getCharacteristics();
				for(int j = 0; j < characs.size(); j++) {
					if(((CharacteristicBean)characs.elementAt(j)).getName().equals(aform.getName())) {
						errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("characteristic.name.exists"));
						returnString = "existing_name";
					}		
				}
				if(errors.empty()) {
					CharacteristicBean charac = new CharacteristicBean();
					charac.setName(aform.getName());
					charac.setDescription(aform.getDescription());
					charac.setScale(aform.getScale());
					
					Connection conn = null;
					try {
						Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       				conn = dataSource.getConnection();					
					
						charac.saveCharacteristicInDB(conn, errors, groupID);
						
       				} catch(Exception sqle) {
		   				servlet.log("Connection.process", sqle);
		   				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   					} finally {
   						if(conn != null){
	   						try {
								conn.close();
	    					} catch (SQLException e){
	        					servlet.log("Connection.close", e);
	        					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
		    				}
		    			}					
					}
					characs.add(charac);
					agroup.setCharacteristics(characs);
					session.setAttribute("group", agroup);
					session.removeAttribute("characteristic");
					session.removeAttribute("addNewCharacteristicForm");
					returnString = "characteristic_added";
				}
				
			}
		saveErrors(request, errors);
        return mapping.findForward(returnString);
        }
}
