package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.*;
import java.io.IOException;
import java.util.Vector;
import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class AddNewGroupAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			
			if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
			else {
				UserBean user = (UserBean)session.getAttribute("user");
				if(user.getAccessLevel().equals("u")) {
					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
					saveErrors(request, errors);
					return mapping.findForward("not_logged_in");
				}
			}
			
			AddNewGroupForm aform = (AddNewGroupForm) form;
			String submit = aform.getSubmit();
			String returnString = "failure";
			
			if(submit != null) {
			
				if(submit.equals("Cancel")) {
					session.removeAttribute("group");
					session.removeAttribute("addNewGroupForm");
					returnString = "cancel";
				}	
				
				else if(submit.equals("Save group")) {
					
					GroupBean agroup = (GroupBean) session.getAttribute("group");
					Vector groups = agroup.getGroups();
					String groupName = aform.getName();
					for(int i = 0; i<groups.size(); i++) {
						if(groupName.equals(((GroupBean)groups.elementAt(i)).getName()))
							errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("group.name.exists"));
					}
						
					if (errors.empty()) {
						agroup.setName(groupName);
						agroup.setDescription(aform.getDescription());
						
						Connection conn = null;
						try {
							Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       					conn = dataSource.getConnection();		
						
							int id = agroup.saveGroupInDB(conn, errors);	
						
							if(id == -1)
								errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
							else {
								agroup.setGroupID(id);
								groups.add(agroup);
							}				
						
       					} catch(Exception sqle) {
			   				servlet.log("Connection.process", sqle);
		   					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   						} finally {
	   						if(conn != null){
		   						try {
									conn.close();
		    					} catch (SQLException e){
		        					servlet.log("Connection.close", e);
		        					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
			    				}
			    			}					
						}		
					}
					if(errors.empty()	)
						returnString = "success";
					else {
						saveErrors(request, errors);
					}
				}
				else {
					returnString = "add_new_group";	
				}
        	}
        	return mapping.findForward(returnString);
        }
}
