package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.*;
import java.io.IOException;
import java.util.Vector;
import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class AddNewRuleAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			
			
			
			if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
			else {
				UserBean user = (UserBean)session.getAttribute("user");
				if(!user.getAccessLevel().equals("a")) {
					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
					saveErrors(request, errors);
					return mapping.findForward("not_logged_in");
				}
			}
			AddNewRuleForm aForm = (AddNewRuleForm) form;
			RuleBean rules = (RuleBean) session.getAttribute("rule");
			String returnString = "failure";
			//String submit = aForm.getSubmit();
			
			if(aForm.getSubmit() != null && aForm.getSubmit().equals("Cancel")) {
				session.removeAttribute("rule");
				session.removeAttribute("addNewRuleForm");
				returnString = "cancel";
			}
			
			else if(aForm.getSubmit() != null && aForm.getSubmit().equals("Add fragment")) {
				
				aForm.addRule(aForm.getCharac());
				aForm.addRule(aForm.getOperator());
				aForm.addRule(new Integer(aForm.getValue()));
				aForm.addRule(aForm.getRelation());
				
				returnString = "added_rule_fragment";
			}
			
			else if(aForm.getSubmit() != null && aForm.getSubmit().equals("Remove fragment")) {
				
				Vector rule = aForm.getRule();
				if(rule.size() != 0) {
					for(int i = 0; i <= 3; i++)
						rule.removeElementAt(rule.size()-1);	
				}
				aForm.setRule(rule);
				
				returnString = "removed_rule_fragment";	
			}
			
			else if(aForm.getSubmit() != null && aForm.getSubmit().equals("Save rule")) {
				
				
				
				Connection conn = null;
				try {
					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       			conn = dataSource.getConnection();					
				
					RuleBean rule = new RuleBean();
					rule.setName(aForm.getName());
					rule.setWarning(aForm.getWarning());					
					
					Vector frag = aForm.getRule();
					while(!frag.isEmpty()) {
						//int test = (new Integer((String)frag.remove(0))).intValue();
						rule.setCharacteristic((String)frag.remove(0));
						rule.setOperator((String)frag.remove(0));
						rule.setValue(((Integer)frag.remove(0)).intValue());
						rule.setRelation((String)frag.remove(0));
						rule.saveRuleInDB(conn, errors);
					}
					//charac.saveCharacteristicInDB(conn, errors, groupID);		
       			}
       			catch(Exception sqle) {
		   			servlet.log("Connection.process", sqle);
		   			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   				} 
   				finally {
   					if(conn != null){
	   					try {
							conn.close();
	    				} 
	    				catch (SQLException e){
	        				servlet.log("Connection.close", e);
	        				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
		    			}
		    		}					
				}
				
				
				session.removeAttribute("rule");
				session.removeAttribute("addNewRuleForm");
				returnString = "rule_added";	
			}
			
			return mapping.findForward(returnString);
		}
	}