package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.ScenarioBean;
import com.mowahs.mwcf.framework.RoleBean;
import com.mowahs.mwcf.framework.TaskBean;
import java.util.Vector;
import java.io.IOException;
import javax.naming.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class AddTaskAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm aform, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
		ActionErrors errors = new ActionErrors();
		HttpSession session = request.getSession();
		String returnString = "failure";
       	AddTaskForm form = (AddTaskForm) aform;
       	
       	if(session.getAttribute("user") == null)
			returnString = "not_logged_in";
        
        else if(form.getSubmit() != null && form.getSubmit().equals("No")) {
        	returnString = "end";
        	session.removeAttribute("addTaskForm");
        }
        else if(request.getParameter("scenarioId") != null) {
        	
        	int id = (new Integer(request.getParameter("scenarioId"))).intValue();
        	ScenarioBean scenario = new ScenarioBean();
        	Connection conn = null;
        	try {
   				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
       			conn = dataSource.getConnection();
        		
        		scenario.getScenarioFromDB(conn, errors, id);	 
        		scenario.getRolesInScenarioFromDB(conn, errors);
        		scenario.getTasksInScenarioFromDB(conn, errors);
        		session.setAttribute("scenario", scenario);
        	
       		} catch(Exception sqle) {
		   		servlet.log("Connection.process", sqle);
	   			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
    					servlet.log("Connection.close", e);
    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    				}
    			}					
			}	
        	returnString = "add";	
	    } else if(request.getParameter("taskId") != null) { 
	        
	        int taskID = (new Integer(request.getParameter("taskId"))).intValue();
	        TaskBean task = new TaskBean();
	        Connection conn = null;
	        try {
	   			Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
		       	conn = dataSource.getConnection();
	        		        
	        	task.getTaskFromDB(conn, errors, taskID);
	        	
   			} catch(Exception sqle) {
	    		servlet.log("Connection.process", sqle);
	    		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("sql.exception"));
   			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
    					servlet.log("Connection.close", e);
    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    				}
    			}					
			}			
	        
	        form.setTaskName(task.getName());
	        form.setTaskDescription(task.getDescription());
	        form.setResponsible(task.getResponsible());
	        form.setPreLocation(task.getPreLocation());
	        form.setPreResources(task.getPreResources());
	        form.setPostLocation(task.getPostLocation());
	        form.setPostResources(task.getPostResources());
	        form.setComposite(task.getComposite());
	        //form.setSubTasks(task.getSubTasks());	
	        
	        returnString = "add";
        } else if(form.getSubmit() != null && form.getSubmit().equals("Cancel")) {
        	returnString = "end";	
        } else if(form.getSubmit() != null && form.getSubmit().equals("Back")) {
        	form.setStep(form.getStep()-1);
    	 		returnString = "add"; 
        	
        } else if(form.getSubmit() != null && form.getStep() == 1 && form.getSubmit().equals("Next")) {
        	String name = form.getTaskName();
        	ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
        	Vector tasks = scenario.getTasks();
        	for (int i = 0; i<tasks.size(); i++) {
        		if(((TaskBean)tasks.elementAt(i)).getName().equals(name))
        			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("tasknames.cannot.match"));	
        	}
        	if(errors.empty()) {
        		form.setStep(2);
        		returnString = "add";
        	} else
        		saveErrors(request, errors);
        
        } else if(form.getSubmit() != null && form.getSubmit().equals("Next") && form.getStep() != 1) {
	 		form.setStep(form.getStep()+1);
	 		returnString = "add";
  		
  		} else if(form.getSubmit() != null && form.getSubmit().equals("Save task")) {
  			TaskBean task = new TaskBean();
		 	task.setName(form.getTaskName());
		 	task.setDescription(form.getTaskDescription());
		 	task.setResponsible(form.getResponsible());
		 	task.setPreLocation(form.getPreLocation());
        	task.setPreResources(form.getPreResources());
        	//setPreTasks
        	Vector preTas = new Vector();
        	int[] preTasks = form.getPreTasks();
        	if(preTasks != null && preTasks[0] != -1)	{
        		for(int i=0; i<preTasks.length; i++)
        			preTas.add(new Integer(preTasks[i]));
        	}
        	task.setPreTasks(preTas);
        	task.setPostLocation(form.getPostLocation());
   			task.setPostResources(form.getPostResources());
   			//setPostTasks
   			int[] postTasks = form.getPostTasks();
   			Vector postTas = new Vector();
   			if(postTasks != null && postTasks[0] != -1 ) {
        		for(int i=0; i<postTasks.length; i++) 
	        		postTas.add(new Integer(postTasks[i]));
    		}
        	task.setPostTasks(postTas);
        	
        	int[] dependencyRoles = form.getDependencyRoles();
        	Vector depRoles = new Vector();
        	if(dependencyRoles != null && dependencyRoles[0] != -1) {
        		for(int i=0; i<dependencyRoles.length; i++)
        			depRoles.add(new Integer(dependencyRoles[i]));	
        	}
        	task.setRoleDependencies(depRoles);
        		      			
        	task.setComposite(form.getComposite());
        	if(form.getComposite().equals("Yes")) {
        		int[] subs = form.getSubTasks();
        		Vector subTasks = new Vector();
   				if(subs != null && subs[0] != -1 ) {
   					
        			for(int i=0; i<subs.length; i++) {
	        			subTasks.add(new Integer(subs[i]));
	        			
	        		}
    			}
    			task.setSubTasks(subTasks);
        	}
        	int taskID = -1;
        	Connection conn = null;
        	try {
   				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
       			conn = dataSource.getConnection();
        	
        		taskID = task.saveTaskInDB(conn, errors);			
        	
   			} catch(Exception sqle) {
	    		servlet.log("Connection.process", sqle);
	    		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("sql.exception"));
   			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
    					servlet.log("Connection.close", e);
    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    				}
    			}					
			}		        		
        	
        	if(taskID != -1) {
        		returnString = "success";
		    	session.setAttribute("task", task);
		    	session.removeAttribute("addTaskForm");
		    } else {
		    	saveErrors(request, errors);
	 			returnString = "failure";
	 		}
	 		ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
	 		Vector tasks = scenario.getTasks();
	 		tasks.addElement(task);
	 		scenario.setTasks(tasks);
	 				
        } else {
        	saveErrors(request, errors);
	 		returnString = "failure";
	 	}	
  			
  		return mapping.findForward(returnString);
       
        }
}
