package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.TaskBean;
import com.mowahs.mwcf.framework.GroupBean;
import com.mowahs.mwcf.framework.CharacteristicBean;
import java.util.Vector;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class CharacteriseGroupAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			CharacteriseGroupForm aform = (CharacteriseGroupForm) form;
			Connection conn =  null;
			
			if(session.getAttribute("user") == null)
				mapping.findForward("not_logged_in");
			
			
			//When user clicks "Save Characterisation"-button
			if((aform != null) && (aform.getSubmit() != null) && (aform.getSubmit().equals("Save characterisation"))) {
				int[] values = aform.getValues();	
				GroupBean agroup = (GroupBean) session.getAttribute("group");
				Vector characteristics = agroup.getCharacteristics();
				
				TaskBean task = (TaskBean) session.getAttribute("task");
				int taskID = task.getTaskID();
				
				
				try {
					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       			conn = dataSource.getConnection();					
					
					for(int j = 0; j<values.length; j++) {
						CharacteristicBean thisChar = (CharacteristicBean)characteristics.elementAt(j);
						if(agroup.getCharacterised() == 1)
							thisChar.updateCharacterisationInDB(conn, errors, values[j], taskID);	
						else
							thisChar.saveCharacterisationInDB(conn, errors, values[j], taskID);	
					}
				
					if(!errors.empty())
						return mapping.findForward("database_failure");
									
       			} catch(Exception sqle) {
		   			servlet.log("Connection.process", sqle);
	   				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   				} finally {
					if(conn != null){
						try {
							conn.close();
						} catch (SQLException e){
	    					servlet.log("Connection.close", e);
	    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    				}
	    			}					
				}				
				
				agroup.setCharacterised(1);
				aform.reset(mapping, request);
				return mapping.findForward("show_groups");
			
			//User has selected a group to characterise the task within	
			} else {
				int id = (new Integer(request.getParameter("groupId"))).intValue();
				GroupBean agroup = (GroupBean) session.getAttribute("group");
				TaskBean task = (TaskBean) session.getAttribute("task");
				try {
					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       			conn = dataSource.getConnection();	
					task.getCharacterisationsOfTaskFromDB(conn, errors);
					session.setAttribute("task", task);	
				} catch(Exception sqle) {
		   			servlet.log("Connection.process", sqle);
	   				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
	   			} finally {
					if(conn != null){
						try {
							conn.close();
						} catch (SQLException e){
	    					servlet.log("Connection.close", e);
	    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    				}
	    			}					
				}				
				int taskID = task.getTaskID();
						
				Vector groups = agroup.getGroups();
				int i = 0;
				
				while(((GroupBean)groups.elementAt(i)).getGroupID() != id)
					i++;
				agroup = (GroupBean)groups.elementAt(i);
				agroup.setGroups(groups);
				session.setAttribute("group", agroup);
										
				return mapping.findForward("success");	
			}
			
        }
}
