package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.*;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.sql.DataSource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class CharacteriseTaskAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			CharacteriseTaskForm cform = (CharacteriseTaskForm) form;
			String returnString = "failure";
			Connection conn = null;
			UserBean user = (UserBean) session.getAttribute("user");
			if(user == null) {
				try {
					session.invalidate();
				} catch (java.lang.IllegalStateException e) {
					//do.nothing
				} finally {
					return mapping.findForward("not_logged_in");
				}
			} 
			
			try {
   				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       		conn = dataSource.getConnection();
			
				//User has selected a weight for the task
				if((cform != null) && (cform.getSubmit() != null) && (cform.getSubmit().equals("Next"))) {
					TaskBean task = (TaskBean) session.getAttribute("task");
					if(task.getWeight() != cform.getWeight()) {
						task.setWeight(cform.getWeight());
						task.saveWeightInDB(conn, errors);
					}
					int taskID = task.getTaskID();
					GroupBean agroup = new GroupBean();
					agroup.getAllGroupsFromDB(conn, errors, taskID);
			
					if(errors.empty())
						session.setAttribute("group", agroup);
						
					returnString = "show_groups";
					
				} else {
					int id = (new Integer(request.getParameter("taskId"))).intValue();
					TaskBean task = new TaskBean();
					RoleBean role = new RoleBean();
					
					task.getTaskFromDB(conn, errors, id);
					role.getRoleFromDB(conn, errors, task.getResponsible());
						
					session.setAttribute("task", task);
					session.setAttribute("role", role);
					
					returnString = "success";	
				}
			} catch(Exception sqle) {
			   		servlet.log("Connection.process", sqle);
		   			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
    					servlet.log("Connection.close", e);
    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    				}
    			}					
			}
		return mapping.findForward(returnString);		
        }
}
