package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.UserBean;
import com.mowahs.mwcf.framework.ScenarioBean;
import com.mowahs.mwcf.framework.RoleBean;
import com.mowahs.mwcf.framework.TaskBean;
import java.util.Vector;
import java.util.Hashtable;
import java.io.IOException;
import javax.naming.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class CreateScenarioAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm aform, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			String returnString = "failure";
			
			if(session.getAttribute("user") == null)
				returnString = "not_logged_in";
			
			else {
            	CreateScenarioForm form = (CreateScenarioForm) aform;
            	String submit = form.getSubmit();
            	int step = form.getStep();
    	 		String roleName = form.getRole();
    	 	
	    	 	if(submit.equals("Next") && (step == 1)) {
	    	 		UserBean user = (UserBean) session.getAttribute("user");
	    	 		Vector scenarios = user.getScenarios();
	    	 		String sceneName = form.getName();
	    	 		if(scenarios != null) {
	    	 			for(int i=0; i<scenarios.size(); i++) {
	    	 				if((((ScenarioBean)scenarios.elementAt(i)).getName()).equals(sceneName))
	    	 					errors.add("scenario.name.exists", new ActionError("scenario.name.exists"));
	    	 			}
	    	 		}
	    	 	} else if(submit.equals("Add") && (form.getNoRoles() == 1)) {
	    	 		Vector roles = new Vector();
	    	 		form.setRoles(roles);
	    	 	}
	    	 	
	    	 	if(submit.equals("Next")) {
	    	 		form.setStep(step+1);
	    	 		returnString = "create";
	    	 	} else if(submit.equals("Back")) {
	    	 		form.setStep(step-1);
	    	 		returnString = "create"; 
	    	 	} else if(submit.equals("Cancel")) {
	    	 		form.doreset(mapping, request);
	    	 		session.removeAttribute("createScenarioForm");
	    	 		returnString = "cancel";	
	    	 	} else if(submit.equals("Add")) {
	    	 		form.addRole(form.getRole());
	    	 		returnString = "create"; 
	    	 	} else if(submit.equals("Finish")) {
	    	 		ScenarioBean scenario = new ScenarioBean();
	    	 		UserBean user = (UserBean) session.getAttribute("user");
	    	 		Vector scenarios = user.getScenarios();
	    	 		String sceneName = form.getName();
	    	 		if(scenarios != null) {
	    	 			for(int i=0; i<scenarios.size(); i++) {
	    	 				if((((ScenarioBean)scenarios.elementAt(i)).getName()).equals(sceneName)) {
	    	 					errors.add("scenario.name.exists", new ActionError("scenario.name.exists"));
	    	 					returnString = "create";
	    	 				}
	    	 			}
	    	 		}
	    	 		if(!errors.empty()){
	    	 			saveErrors(request, errors);
	    	 		} else {
	    	 			Connection conn = null;
	    	 			try {
	   						Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
		       				conn = dataSource.getConnection();
	        			
			    	 		scenario.setName(form.getName());
				 			scenario.setDescription(form.getDescription());
				 			Vector rolesScenario = new Vector();
			    	 		scenario.setRoles(rolesScenario);
			    	 		   	 		
			    	 		Vector roles = form.getRoles();
			    	 		for(int i=0; i<roles.size(); i++)	{
			    	 			RoleBean role = new RoleBean();
			    	 			role.setName((String)roles.elementAt(i));
			    	 			scenario.addRole(role);	
			    	 		}
			    	 		int userID = user.getUserID();
			        		int scenarioID = scenario.saveScenarioInDB(conn, errors, userID);
			        		
			        		if(scenarioID != -1 && errors.empty()) {
			        			
			        			TaskBean task = new TaskBean();
					 			task.setName(form.getTaskName());
					 			task.setDescription(form.getTaskDescription());
					 			
					 			Hashtable rolesHash = scenario.getRoleIDs();
					 			int resp = ((Integer)rolesHash.get(form.getResponsible())).intValue();
					 			task.setResponsible(resp);
					 			task.setResponsibleName(form.getResponsible());
			        			task.setPreLocation(form.getPreLocation());
			        			task.setPreResources(form.getPreResources());
			        			task.setPostLocation(form.getPostLocation());
			        			task.setPostResources(form.getPostResources());
			        			//Setting empty vectors for pre and post tasks, since this is the first 
			        			//task in this scenario and no other tasks exist.
			        			Vector pt = new Vector();
			        			task.setPreTasks(pt);
			        			task.setPostTasks(pt);
			        			
			        			Vector depRoles = new Vector();
			        			String[] dependencyRoles = form.getDependencyRoles();
			        			if(dependencyRoles != null && !dependencyRoles[0].equals("none")) {
			        				int len = dependencyRoles.length;
			        				for(int i=0; i<len; i++) {
			        					depRoles.add(rolesHash.get(dependencyRoles[i]));
			        				}
			        			}
			        			task.setRoleDependencies(depRoles);
			        			
			        			if(form.getComposite().equals("Yes"))
			        				task.setComposite("Yes");
			        			else
			        				task.setComposite("No");
			        			
			        			int taskID = task.saveTaskInDB(conn, errors);			
			        			
			        			if(taskID != -1) {
			        			    
			        			    Vector tasks = new Vector();
			        			    tasks.addElement(task);
			        			    scenario.setTasks(tasks);		
					    			user.addScenario(scenario);
					    			session.setAttribute("scenario", scenario);
					    			session.setAttribute("task", task);
					    			session.removeAttribute("createScenarioForm");
					    			returnString = "success";
					    			
					    		} else {
					    			saveErrors(request, errors);
				 					returnString = "failure";
				 				}
			        		} else {
			        			saveErrors(request, errors);
				 				returnString = "failure";
				 			}
   						} catch(Exception sqle) {
	    					servlet.log("Connection.process", sqle);
	    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("sql.exception"));
   						} finally {
							if(conn != null){
								try {
									conn.close();
								} catch (SQLException e){
			    					servlet.log("Connection.close", e);
			    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
			    				}
			    			}					
						}	
		    	 	}	
	            }
	        }
            return mapping.findForward(returnString);
        }
}
