package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.GroupBean;
import com.mowahs.mwcf.framework.UserBean;
import java.io.IOException;
import java.util.Vector;
import javax.sql.DataSource;
import javax.naming.*;
import java.sql.Connection;
import java.sql.SQLException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class DeleteGroupAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
			else {
				UserBean user = (UserBean)session.getAttribute("user");
				if(user.getAccessLevel().equals("u")) {
					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
					saveErrors(request, errors);
					return mapping.findForward("not_logged_in");
				}
			}
				
			String returnString = "failure";
			if(request.getParameter("groupId") != null) {
			
				int id = (new Integer(request.getParameter("groupId"))).intValue();
				GroupBean agroup = (GroupBean) session.getAttribute("group");
				if(agroup == null)
					agroup = new GroupBean();
					
				Connection conn = null;
				try {
	   				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
		       		conn = dataSource.getConnection();
		       		
					agroup.removeGroupFromDB(conn, errors, id);
				
       			} catch(Exception sqle) {
			   		servlet.log("Connection.process", sqle);
		   			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   				} finally {
					if(conn != null){
						try {
							conn.close();
						} catch (SQLException e){
	    					servlet.log("Connection.close", e);
	    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    				}
	    			}					
				}		
   				
				Vector groups = agroup.getGroups();
				int i = 0;
				while(((GroupBean)groups.elementAt(i)).getGroupID() != id)
						i++;
				groups.remove(i);
				agroup.setGroups(groups);
				
				if(!errors.empty()) {
					saveErrors(request, errors);
					returnString = "failure";
				}
				returnString = "deleted";	
			}
		return mapping.findForward(returnString);
        }
}
