package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.TaskBean;
import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.sql.DataSource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class DeleteTaskAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			
			HttpSession session = request.getSession();
			if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
			
			ActionErrors errors = new ActionErrors();
			if(request.getParameter("taskId") == null) {
				return mapping.findForward("failure");
			} else {
				int id = (new Integer(request.getParameter("taskId"))).intValue();	
				TaskBean task = new TaskBean();
				Connection conn = null;
				try {
		   			Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
			       	conn = dataSource.getConnection();
					task.removeTaskFromDB(conn, errors, id);
			
				} catch(Exception sqle) {
	    			servlet.log("Connection.process", sqle);
	    			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.deleted"));
   				} finally {
					if(conn != null){
						try {
							conn.close();
						} catch (SQLException e){
	    					servlet.log("Connection.close", e);
	    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    				}
	    			}					
				}				
					
				if(!errors.empty()) {
					saveErrors(request, errors);	
				}
				return mapping.findForward("deleted");	
			}
        }
}
