package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.*;
import java.io.IOException;
import java.util.Vector;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.sql.DataSource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class EditCharacteristicAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			HttpSession session = request.getSession();
			ActionErrors errors = new ActionErrors();
			if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
			else {
				UserBean user = (UserBean)session.getAttribute("user");
				if(!user.getAccessLevel().equals("a")) {
					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
					saveErrors(request, errors);
					return mapping.findForward("not_logged_in");
				}
			}
			
			
			AddNewCharacteristicForm aform = (AddNewCharacteristicForm) form;
			String returnString = "failure";
						
			if(request.getParameter("characId") != null) {
				int id = (new Integer(request.getParameter("characId"))).intValue();
				GroupBean agroup = (GroupBean) session.getAttribute("group");
				Vector characs = agroup.getCharacteristics();
				
				int i = 0;
				while(((CharacteristicBean)characs.elementAt(i)).getCharacteristicID() != id)
						i++;
				CharacteristicBean charac = (CharacteristicBean)characs.elementAt(i);
				
				aform.setName(charac.getName());
				aform.setDescription(charac.getDescription());
				aform.setScale(charac.getScale());
				
				if(!errors.empty()) {
					saveErrors(request, errors);
					return mapping.findForward("failure");
				}
				session.setAttribute("characteristic",charac);
				return mapping.findForward("got_characteristic");	
			} else if(request.getParameter("elementNo") != null) {
				int element = (new Integer(request.getParameter("elementNo"))).intValue();
				Vector scale = aform.getScale();
				scale.removeElementAt(element);
				scale.removeElementAt(element);
				aform.setScale(scale);
				return mapping.findForward("removed_scale_element");
				
			} else if(aform.getSubmit() != null && (aform.getSubmit().equals("Cancel") || aform.getSubmit().equals("Back to framework"))) {
				session.removeAttribute("characteristic");
				session.removeAttribute("addNewCharacteristicForm");
				return mapping.findForward("cancel");
			}					
			else if(aform.getSubmit() != null && aform.getSubmit().equals("Add value to scale")) {
				aform.addToScale(new Integer(aform.getValue()));
				aform.addToScale(aform.getValueDescription());
				return mapping.findForward("added_scale_element");
			}

			else if(aform.getSubmit() != null && aform.getSubmit().equals("Update characteristic")) {
				
				CharacteristicBean charac = (CharacteristicBean) session.getAttribute("characteristic");
				charac.setName(aform.getName());
				charac.setDescription(aform.getDescription());
				charac.setScale(aform.getScale());
				
				Connection conn = null;
				try {
					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       			conn = dataSource.getConnection();	
	       				
					charac.updateCharacteristicInDB(conn, errors);
				
   				} catch(Exception sqle) {
	   				servlet.log("Connection.process", sqle);
	   				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
				} finally {
					if(conn != null){
						try {
							conn.close();
						} catch (SQLException e){
	    					servlet.log("Connection.close", e);
	    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    				}
	    			}					
				}		
				
				if(!errors.empty())	{
					saveErrors(request, errors);
					returnString = "failure";
				}
				else
					returnString = "updated";
				session.removeAttribute("addNewCharacteristicForm");
			}
			return mapping.findForward(returnString);
       }
}
