package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.*;
import java.io.IOException;
import java.util.Vector;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class EditGroupAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			HttpSession session = request.getSession();
			ActionErrors errors = new ActionErrors();
			
			if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
			else {
				UserBean user = (UserBean)session.getAttribute("user");
				if(user.getAccessLevel().equals("u")) {
					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
					saveErrors(request, errors);
					return mapping.findForward("not_logged_in");
				}
			}
			
			EditGroupForm aform = (EditGroupForm) form;
			GroupBean agroup = (GroupBean) session.getAttribute("group");
			
			if(aform.getSubmit() != null && aform.getSubmit().equals("Cancel"))
				return mapping.findForward("cancel");
			
			else if(aform.getSubmit() != null && aform.getSubmit().equals("Update group")) {
				if(!(agroup.getName().equals(aform.getName())) || !(agroup.getDescription().equals(aform.getDescription()))) {
					agroup.setName(aform.getName());
					agroup.setDescription(aform.getDescription());
					Connection conn = null;
					try {
	   					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
		       			conn = dataSource.getConnection();
		       		
						agroup.updateGroupInDB(conn, errors);
					
       				} catch(Exception sqle) {
				   		servlet.log("Connection.process", sqle);
		   				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   					} finally {
						if(conn != null){
							try {
								conn.close();
							} catch (SQLException e){
		    					servlet.log("Connection.close", e);
		    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
		    				}
		    			}					
					}		
					
					return mapping.findForward("updated_group");
				}
			}
			else if(request.getParameter("groupId") != null)	{					
				int id = (new Integer(request.getParameter("groupId"))).intValue();
				Vector groups = agroup.getGroups();
				int i = 0;
				while(((GroupBean)groups.elementAt(i)).getGroupID() != id)
					i++;
				agroup = (GroupBean)groups.elementAt(i);
				agroup.setGroups(groups);
			}
			 
			aform.setName(agroup.getName());
			aform.setDescription(agroup.getDescription());
			
			if(!errors.empty()) {
				saveErrors(request, errors);
				return mapping.findForward("failure");
			}
			session.setAttribute("group",agroup);
			return mapping.findForward("got_group");	
        }
}
