package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.IndicatorBean;
import com.mowahs.mwcf.framework.GroupBean;
import com.mowahs.mwcf.framework.UserBean;
import java.io.IOException;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class EditIndicatorAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			HttpSession session = request.getSession();
			ActionErrors errors = new ActionErrors();
			UserBean user = (UserBean)session.getAttribute("user");
			if(user == null){
				System.out.println("User null");
				return mapping.findForward("not_logged_in");
			
			} else if(user.getAccessLevel().equals("u")) {
				System.out.println("u");
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("admin.level.action"));
				saveErrors(request, errors);
				return mapping.findForward("not_logged_in");
			
			} else if (user.getAccessLevel().equals("a")) {
			
				IndicatorForm aform = (IndicatorForm) form;
				String submit = aform.getSubmit();
							
				String returnString	= "failure";
				if(submit != null && submit.equals("Cancel")) {
					session.removeAttribute("indicator");
					return mapping.findForward("cancel");
				
				} else if(submit != null) {
				
					 if(submit.equals("Update")) {
						
						IndicatorBean indi = (IndicatorBean)session.getAttribute("indicator");
						if(indi != null) {
							boolean updated = false;
							if((indi.getName() == null) || (indi.getName() != null && !indi.getName().equals(aform.getName()))) {
								indi.setName(aform.getName());
								updated = true;
							}
							if(indi.getDescription() == null || (indi.getDescription() != null && !indi.getDescription().equals(aform.getDescription()))) {
								indi.setDescription(aform.getDescription());
								updated = true;
							}
							if(updated) {
								Connection conn = null;
								try {
	   								Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       							conn = dataSource.getConnection();
	       							if(indi.getName() != null && indi.getName().equals(aform.getName()))
	       							{
	       								indi.updateIndicatorNameDescriptionInDB(conn, errors, indi.getIndicatorID());
										indi.getIndicatorFromDB(conn, errors, indi.getIndicatorID());
	       							}
									else if(indi.isNameUnique(conn, errors, indi.getName())) {
													
										indi.updateIndicatorNameDescriptionInDB(conn, errors, indi.getIndicatorID());
									
										indi.getIndicatorFromDB(conn, errors, indi.getIndicatorID());
									} else {
										errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("indicator.name.exists"));				
									}
								} catch(Exception sqle) {
						   			servlet.log("Connection.process", sqle);
					    			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
				   				} finally {
									if(conn != null){
										try {
											conn.close();
										} catch (SQLException e){
							    			servlet.log("Connection.close", e);
							    			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
							    		}
							    	}					
								}	
							}
						
							if(!errors.empty()) {
								saveErrors(request, errors);
								returnString = "failure";
							} else
								returnString = "updated";
						
							aform.setName(indi.getName());
							aform.setDescription(indi.getDescription());		
						}
									
					} else if (submit.equals("Edit") || submit.equals("Back")) {
						aform.setCurrentStep("1");
						returnString = "next";
										
					} else if(submit.equals("Next")) {
											
						int[] prime = aform.getPrimary();
						
						if(prime == null || prime.length == 0)
							errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("key.characteristics.required"));
						else {
							IndicatorBean indi = (IndicatorBean)session.getAttribute("indicator");
							indi.setPrimaryContent(prime);
						}
						aform.setCurrentStep("2");
						returnString = "next";
						
					} else if(submit.equals("Update characteristics")) {
						int[] secondary = aform.getSecondary();
												
						IndicatorBean indi = (IndicatorBean) session.getAttribute("indicator");
						indi.setSecondaryContent(secondary);
						
						Connection conn = null;
						try {
	   						Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       					conn = dataSource.getConnection();
											
							indi.updateIndicatorInDB(conn, errors, indi.getIndicatorID());
							indi.getIndicatorFromDB(conn, errors, indi.getIndicatorID());
													
	        			} catch(Exception sqle) {
			   				servlet.log("Connection.process", sqle);
		    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
	   					} finally {
							if(conn != null){
								try {
									conn.close();
								} catch (SQLException e){
				    				servlet.log("Connection.close", e);
				    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
				    			}
				    		}					
						}		
						if(!errors.empty()) {
							saveErrors(request, errors);
							returnString = "failure";
						} else
							returnString = "updated";
						aform.setName(indi.getName());
						aform.setDescription(indi.getDescription());
					}
	        	} else if(request.getParameter("indicatorId") != null)	{					
					int id = (new Integer(request.getParameter("indicatorId"))).intValue();
	        		IndicatorBean indi = (IndicatorBean) session.getAttribute("indicator");
	        		if(indi == null)
	        			indi = new IndicatorBean();
	        		GroupBean agroup = new GroupBean();
	        		        		
	        		Connection conn = null;
	        		try {
	   					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       				conn = dataSource.getConnection();
	        			
	        			indi.getIndicatorFromDB(conn, errors, id);
	        			
	        			aform.setName(indi.getName());
	        			aform.setDescription(indi.getDescription());
	        			aform.setPrimary(indi.getPrimaryContent());
	        			aform.setSecondary(indi.getSecondaryContent());
	        			        			
	        			agroup.getAllGroupsFromDB(conn, errors);
	        			if(errors.empty()) {
	        				session.setAttribute("group", agroup);
	        				session.setAttribute("indicator", indi);
	        				returnString = "success";
	        			}
	        		
	        		} catch(Exception sqle) {
			   			servlet.log("Connection.process", sqle);
		    			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
	   				} finally {
						if(conn != null){
							try {
								conn.close();
							} catch (SQLException e){
			    				servlet.log("Connection.close", e);
			    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
			    			}
			    		}					
					}
					saveErrors(request, errors);		
	        	}
	        	return mapping.findForward(returnString);
	        	
	        } else {
				System.out.println("else");
				return mapping.findForward("not_logged_in");      
			}
	    }
}
