package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.ScenarioBean;
import com.mowahs.mwcf.framework.RoleBean;
import java.io.IOException;
import javax.naming.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class EditScenarioAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm aform, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
	
		HttpSession session = request.getSession();
		if(session.getAttribute("user") == null)
				return mapping.findForward("not_logged_in");
       	
       	ActionErrors errors = new ActionErrors(); 
       	CreateScenarioForm form = (CreateScenarioForm) aform;
        
        //If the user clicks the "Cancel" button
		if(form.getSubmit() != null && form.getSubmit().equals("Cancel"))
			return mapping.findForward("cancel");	
        
        Connection conn = null;
        try {
   			Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
   			conn = dataSource.getConnection();
       	
	       	//At first call
	       	if(request.getParameter("scenarioId") != null) {
	        	int scenarioID = (new Integer(request.getParameter("scenarioId"))).intValue();
	       		ScenarioBean scenario = new ScenarioBean();
	       		
	   			scenario.getScenarioFromDB(conn, errors, scenarioID);    	 	
	 			scenario.getRolesInScenarioFromDB(conn, errors);
	 			scenario.getTasksInScenarioFromDB(conn, errors);
		    				
				form.setName(scenario.getName());
				form.setDescription(scenario.getDescription());
				    	 	
		 		session.setAttribute("scenario", scenario);
		 	
		 	//If the user adds a new role
		 	} else if (form.getSubmit() != null && form.getSubmit().equals("Add")) {
		 		
		 		int ID = form.getScenarioID();
		 		RoleBean role = new RoleBean();
		 		role.setName(form.getRole());
		 		role.saveRoleInDB(conn, errors, ID);
		 		
		 		if(errors.empty()) {
		 			ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
		 			scenario.getRolesInScenarioFromDB(conn, errors);	 		
		 		} else 
		 			saveErrors(request, errors);
		 	
		 	//If the user deletes a role
		 	} else if(request.getParameter("roleId") != null) {
		 		
	 	 		RoleBean role = new RoleBean();
		 		int roleID = (new Integer(request.getParameter("roleId"))).intValue();
		 		role.removeRoleFromDB(conn, errors, roleID);
		 		if(errors.empty()) {
	 		       			
					ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
					if(scenario != null) {
						scenario.getRolesInScenarioFromDB(conn, errors);
						scenario.getTasksInScenarioFromDB(conn, errors);
		 			}
		 			if(form != null) {
		 				form.setName(scenario.getName());
						form.setDescription(scenario.getDescription());
					}
	 			} else
	 				saveErrors(request, errors);
		 	
			//If the user has changed the name or description of the scenario
			} else if(form.getSubmit() != null && form.getSubmit().equals("Update scenario")) {
				ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
				
				if(form.getName() != null && form.getDescription() != null) {
					 
					String newName = form.getName();
					String newDescription = form.getDescription();
					
					if(!newName.equals(scenario.getName()) || !newDescription.equals(scenario.getDescription())) {
					
						if(!newName.equals(scenario.getName()))
							scenario.setName(newName);
					
						if(!newDescription.equals(scenario.getDescription()))
							scenario.setDescription(newDescription);
						
						int ID = scenario.getScenarioID();
						if(ID > 0) {
								scenario.updateScenarioInDB(conn, errors, ID);
								
						}					
						if(!errors.empty())
							saveErrors(request, errors);
					}	
				}
			} else if(session.getAttribute("scenario") != null) {
				ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
			
				scenario.getScenarioFromDB(conn, errors, scenario.getScenarioID());    	 	
	 			scenario.getRolesInScenarioFromDB(conn, errors);
	 			scenario.getTasksInScenarioFromDB(conn, errors);
			
				form.setName(scenario.getName());
				form.setDescription(scenario.getDescription());
			}
		} catch(Exception sqle) {
			servlet.log("Connection.process", sqle);
	   		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
   		} finally {
			if(conn != null){
				try {
					conn.close();
				} catch (SQLException e){
    				servlet.log("Connection.close", e);
    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    			}
    		}					
		}	
   		return mapping.findForward("success");
    }
}
