package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.TaskBean;
import java.util.Vector;
import java.io.IOException;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class EditTaskAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm aform, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
		
		HttpSession session = request.getSession();
		if(session.getAttribute("user") == null)
			return mapping.findForward("not_logged_in");
		
		ActionErrors errors = new ActionErrors();
		String returnString = "failure";
       	AddTaskForm form = (AddTaskForm) aform;
       	
        if(form.getSubmit() != null && form.getSubmit().equals("No")) {
        	returnString = "end";
        	session.removeAttribute("addTaskForm");
        }
        else if(request.getParameter("taskId") != null) { 
	        
	        int taskID = (new Integer(request.getParameter("taskId"))).intValue();
	        TaskBean task = new TaskBean();
	        
	        Connection conn = null;
	        try {
	   		Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
		       	conn = dataSource.getConnection();
	        		        
	        	task.getTaskFromDB(conn, errors, taskID);
	        
   			} catch(Exception sqle) {
	    		servlet.log("Connection.process", sqle);
	    		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("sql.exception"));
   			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
	    				servlet.log("Connection.close", e);
	    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    			}
	    		}					
			}		
	        form.setTaskID(task.getTaskID());
	        form.setTaskName(task.getName());
	        form.setTaskDescription(task.getDescription());
	        form.setResponsible(task.getResponsible());
	        form.setPreLocation(task.getPreLocation());
	        form.setPreResources(task.getPreResources());
	        Vector pretasks = task.getPreTasks();
	        if(pretasks != null && pretasks.size() > 0 ) {
	        	int[] pre = new int[pretasks.size()];
	        	for(int i=0; i<pretasks.size(); i++)
	        		pre[i] = ((Integer)pretasks.elementAt(i)).intValue();
	        	form.setPreTasks(pre);
	        }
	     	form.setPostLocation(task.getPostLocation());
	        form.setPostResources(task.getPostResources());
	        Vector posttasks = task.getPostTasks();
	        if(posttasks != null && posttasks.size() > 0 ) {
	        	int[] post = new int[posttasks.size()];
	        	for(int i=0; i<posttasks.size(); i++)
	        		post[i] = ((Integer)posttasks.elementAt(i)).intValue();
	        	form.setPostTasks(post);
	        }
	        form.setComposite(task.getComposite());
	        Vector subtasks = task.getSubTasks();
	        if(subtasks != null && subtasks.size() > 0 ) {
	        	int[] sub = new int[subtasks.size()];
	        	for(int i=0; i<subtasks.size(); i++)
	        		sub[i] = ((Integer)subtasks.elementAt(i)).intValue();
	        	form.setSubTasks(sub);
	        }
	        
	        returnString = "add";
        } else if(form.getSubmit() != null && form.getSubmit().equals("Cancel")) {
        	returnString = "end";	
        } else if(form.getSubmit() != null && form.getSubmit().equals("Back")) {
        	if(form.getStep() > 1)
        		form.setStep(form.getStep()-1);
    	 	returnString = "add"; 
        	
        } else if(form.getSubmit() != null && form.getSubmit().equals("Next")) {
	 		if(form.getStep() < 4)
	 			form.setStep(form.getStep()+1);
	 		returnString = "add";
  		
  		} else if(form.getSubmit() != null && form.getSubmit().equals("Update task")) {
  			
  			int taskID = form.getTaskID();
  			TaskBean task = new TaskBean();
  			task.setTaskID(taskID);  			
		 	task.setName(form.getTaskName());
		 	task.setDescription(form.getTaskDescription());
		 	task.setResponsible(form.getResponsible());
		 	task.setPreLocation(form.getPreLocation());
        	task.setPreResources(form.getPreResources());
        	//setPreTasks
        	Vector preTas = new Vector();
        	int[] preTasks = form.getPreTasks();
        	if(preTasks != null && preTasks[0] != -1)	{
        		for(int i=0; i<preTasks.length; i++)
        			preTas.add(new Integer(preTasks[i]));
        	}
        	task.setPreTasks(preTas);
        	task.setPostLocation(form.getPostLocation());
   			task.setPostResources(form.getPostResources());
   			//setPostTasks
   			int[] postTasks = form.getPostTasks();
   			Vector postTas = new Vector();
   			if(postTasks != null && postTasks[0] != -1 ) {
        		for(int i=0; i<postTasks.length; i++) 
	        		postTas.add(new Integer(postTasks[i]));
    		}
        	task.setPostTasks(postTas);
        	
        	int[] dependencyRoles = form.getDependencyRoles();
        	Vector depRoles = new Vector();
        	if(dependencyRoles != null && dependencyRoles[0] != -1) {
        		for(int i=0; i<dependencyRoles.length; i++)
        			depRoles.add(new Integer(dependencyRoles[i]));	
        	}
        	task.setRoleDependencies(depRoles);
        		      			
        	task.setComposite(form.getComposite());
        	if(form.getComposite().equals("Yes")) {
        		int[] subs = form.getSubTasks();
        		Vector subTasks = new Vector();
   				if(subs != null && subs[0] != -1 ) {
   					for(int i=0; i<subs.length; i++) {
	        			subTasks.add(new Integer(subs[i]));
	        			
	        		}
    			}
    			task.setSubTasks(subTasks);
        	}
        	Connection conn = null;
        	try {
	   			Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
		       	conn = dataSource.getConnection();
	        		        
	        	task.updateTaskInDB(conn, errors, taskID);	
	        	
   			} catch(Exception sqle) {
	    		servlet.log("Connection.process", sqle);
	    		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("sql.exception"));
   			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
	    				servlet.log("Connection.close", e);
	    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    			}
	    		}					
			}	
        	
        	
        	if(errors.empty()) {
        		session.removeAttribute("addTaskForm");	
        	}
        	returnString = "success";
        	saveErrors(request, errors);
	 				
        } else {
        	saveErrors(request, errors);
	 		returnString = "failure";
	 	}	
  		
      	return mapping.findForward(returnString);
         		
        }
}
