package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.UserBean;
import com.mowahs.mwcf.framework.ScenarioBean;
import java.io.IOException;
import java.util.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import javax.naming.*;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.util.MessageResources;
import javax.mail.*;
import javax.mail.internet.*;

public final class LoginAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			ActionErrors errors = new ActionErrors();
            String email = ((LoginForm) form).getEmail();
            String password = ((LoginForm) form).getPassword();
            String submit = ((LoginForm) form).getSubmit();
            String returnString = "failure";
    	  	    	 	
    	 	UserBean user = new UserBean();
    	 	ScenarioBean scenario = new ScenarioBean();
    	 	Connection conn = null;
    	 	try {
				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
				conn = dataSource.getConnection();
			
				if(submit != null && submit.equals("Login")) {
	    	 	 	if(user.validateUser(conn, errors, email, password)) {
	    	 	 		Vector scenarios = scenario.getScenariosFromDB(conn, errors, user.getUserID());
	    	 	 		user.setScenarios(scenarios);
			       		HttpSession session = request.getSession();
			       		session.setMaxInactiveInterval(3600);
			       		session.setAttribute("user", user);
			       		returnString = "success";	
			                    	
	        		} else {
	        			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.invalid.login"));
	        			returnString = "failure";
	        		}
	        	} else if(submit != null && submit.equals("Get password")) {
	        		if(email != null) {
	        			String pwd = user.getPasswordFromDB(conn, errors, email);
	        			if(pwd.length() > 0 || !pwd.equals("")) {	        			
		        			try {
		        				MessageResources msg = getResources();
		        				String host = msg.getMessage(defaultLocale, "mail.smtp.host");
		        			    String fromAdr = msg.getMessage(defaultLocale, "mail.from.address");
		        			    
		        			    Properties props = System.getProperties();
		        			    props.put("mail.smtp.host", host);
								Session session = Session.getDefaultInstance(props, null);
								MimeMessage message = new MimeMessage(session);
								
							    // Change this field to the web administrator's email address
							    message.setFrom(new InternetAddress(fromAdr));
								
							    message.addRecipient(Message.RecipientType.TO, new InternetAddress(email));
								message.setSubject("Your MWCF password");
								message.setText("Your password for accessing the MWCF web system is: "+pwd);
								
							    // Send message
							    try {
							    	Transport.send(message);
					        		System.out.println("Sending message...");
					        		returnString = "mail_sent";
					        	} catch(SendFailedException e) {
					        		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("email.failed"));			        		
					        	}
					        	
							} catch (Exception e) {
								errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("email.failed"));	
								returnString = "failure";
							}
						}	
	        		}	        		
	        	}
			} catch(Exception sqle) {
				servlet.log("Connection.process", sqle);
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
			} finally {
				if(conn != null) {
					try {
						conn.close();
					} catch (SQLException e){
						servlet.log("Connection.close", e);
						errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
					}
				}
			}
			if(!errors.empty())
				saveErrors(request, errors);
            return mapping.findForward(returnString);
        }
}
