package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.UserBean;
import java.io.IOException;
import javax.naming.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class RegisterAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm aform, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
		ActionErrors errors = new ActionErrors();
		RegisterForm form = (RegisterForm) aform;
		String returnString = "failure";
			
	  	if(form != null && form.getEmail() != null) {
	        String email = form.getEmail();
	        String password = form.getPassword();
	        String name = form.getName();
	                      	    	 	
	    	UserBean user = new UserBean();
	    	
	    	Connection conn = null;
	    	try {
				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
				conn = dataSource.getConnection();
				
		     	if(user.isEmailUnique(conn, errors, email)) {
			   	 	user.setEmail(email);
			   	 	user.setPassword(password);
			   	 	user.setName(name);
			   	 	user.setAccessLevel("u");
			   	 	user.saveUserInDB(conn, errors);
			   	 	  	 	
			   	 	HttpSession session = request.getSession();
			   	 	session.setAttribute("user", user);
			   	 	System.out.println("Set the user in the session");
			   	 	returnString = "success";
			   	} else {
			   		returnString = "failure";
			   		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.email.not.unique"));
			   		saveErrors(request, errors);
			   	}
			   
			} catch(Exception sqle) {
				servlet.log("Connection.process", sqle);
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
	    				servlet.log("Connection.close", e);
	    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    			}
	    		}					
			}			
	    }
	    return mapping.findForward(returnString);
	}
}
