package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.RuleBean;
import com.mowahs.mwcf.framework.CharacteristicBean;
import com.mowahs.mwcf.framework.UserBean;
import com.mowahs.mwcf.framework.TaskBean;
import java.io.IOException;
import java.util.Vector;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class ShowRuleAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
		ActionErrors errors = new ActionErrors();
		HttpSession session = request.getSession();
		
		if(session.getAttribute("user") == null)
			return mapping.findForward("not_logged_in");
			
		ShowRuleForm aForm = (ShowRuleForm)form;
		Connection conn = null;
		
		
	if(aForm.getSubmit() != null && aForm.getSubmit().equals("Save")) {
		TaskBean task = (TaskBean)session.getAttribute("task");
		CharacteristicBean charac = (CharacteristicBean)session.getAttribute("rulecharacs");
		CharacteristicBean thischarac;
		Vector characs = charac.getCharacteristics();
		int taskID = task.getTaskID();
		int[] values = aForm.getNewValues();
		try {
   			Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
       		conn = dataSource.getConnection();
			for(int i=0; i < values.length; i++) {
				thischarac = (CharacteristicBean)characs.elementAt(i);
				thischarac.updateCharacterisationInDB(conn, errors, values[i], taskID);			
			}
		} catch(Exception sqle) {
				servlet.log("Connection.process", sqle);
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
  		} finally {
			if(conn != null){
				try {
					conn.close();
				} catch (SQLException e){
    				servlet.log("Connection.close", e);
    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    			}
    		}					
		}
		if(!errors.empty()) {
				return mapping.findForward("database_failure");
			}
		return mapping.findForward("saved");	
    		
    }	
		
		
	if(request.getParameter("ruleName") != null) {
			String name = request.getParameter("ruleName");
			RuleBean rule = new RuleBean();
			RuleBean rulefragment = new RuleBean();
			CharacteristicBean charac = new CharacteristicBean();
			CharacteristicBean thischarac = new CharacteristicBean();
			Vector rulefragments;
			Vector characs;
			Vector characteristicIDs = new Vector();
			try {
   				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
       			conn = dataSource.getConnection();
				rule.getRuleFromDB(conn, errors, name);
				rulefragments = rule.getRules();
				int j = rulefragments.size();
				for(int i = 0; i < j; i++) {
					rulefragment = (RuleBean)rulefragments.elementAt(i);
					characteristicIDs.add(new Integer(rulefragment.getCharacteristicID()));
				}
				charac.getCharacteristicsFromDB(conn, errors, characteristicIDs);
				characs = charac.getCharacteristics();
				for(int i = 0; i < j; i++) {
					thischarac = (CharacteristicBean)characs.elementAt(i);
					thischarac.getScalesFromDB(conn, errors);
				}
				session.setAttribute("rulecharacs", charac);
				session.setAttribute("showrule", rule);
				
				

   			} catch(Exception sqle) {
				servlet.log("Connection.process", sqle);
				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
  			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
    					servlet.log("Connection.close", e);
    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    				}
    			}					
			}		
			
			if(!errors.empty()) {
				saveErrors(request, errors);
			}
			return mapping.findForward("success");			
    	} 
    	else {
    		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.url"));
    		return mapping.findForward("failure");	
    	}
	}
		
	
}