package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.UserBean;
import java.io.IOException;
import javax.naming.*;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class UserAccountAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
		
		HttpSession session = request.getSession();
		UserBean user = (UserBean) session.getAttribute("user");
		if(user == null)
			return mapping.findForward("not_logged_in");
			
		ActionErrors errors = new ActionErrors();
		UserAccountForm aform = (UserAccountForm) form;
		String returnString = "failure";
	 	
	 	Connection conn = null;
	 	try {
			Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
			conn = dataSource.getConnection();
		 	
		 	if(aform.getName() == null) {
				if(request.getParameter("userId") != null) {
			 		int id = (new Integer(request.getParameter("userId"))).intValue();
			 		user = new UserBean();
			 		user.getUserFromDB(conn, errors, id);
					 		 		
			 	} else {
			 		user = (UserBean) session.getAttribute("user");
			 	}
		 		aform.setName(user.getName());
		 		aform.setEmail(user.getEmail());
		 		aform.setPassword(user.getPassword());
		 		aform.setUserID(user.getUserID());
		 		aform.setAccessLevel(user.getAccessLevel());
		 		returnString = "got_user";
		 	} else if (aform.getSubmit() != null) {
		 		if(aform.getSubmit().equals("Cancel"))
					returnString = "cancel";
				else if (aform.getSubmit().equals("Save changes")) {
					user = (UserBean) session.getAttribute("user");
					boolean admin = false;
					if(user.getUserID() != aform.getUserID()){
						user = new UserBean();
						admin = true;
					}
					boolean toUpdate = false;
					if(!admin) {
						if(!user.getEmail().equals(aform.getEmail())) {
							if(user.isEmailUnique(conn, errors, aform.getEmail())) {
								toUpdate = true;
							} else
								errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("email.not.unique"));
						} else if(!user.getName().equals(aform.getName())) {
							toUpdate = true;
						} else if(!user.getPassword().equals(aform.getPassword())) {
							toUpdate = true;	
						} else if(!user.getAccessLevel().equals(aform.getAccessLevel())) {
							toUpdate = true;
						}				
					} else {
						toUpdate = true;
					}
					if(toUpdate)
						user.updateUserInDB(conn, errors, aform.getUserID(), aform.getEmail(), aform.getPassword(), aform.getName(), aform.getAccessLevel());
					
					if(!errors.empty()) {
						saveErrors(request, errors);
						returnString = "failure";
					}
					else					
						returnString = "updated";
				}		
			}
		
		} catch(Exception sqle) {
			servlet.log("Connection.process", sqle);
			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
		} finally {
			if(conn != null){
				try {
					conn.close();
				} catch (SQLException e){
    				servlet.log("Connection.close", e);
    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    			}
    		}					
		}				
	    	
        return mapping.findForward(returnString);
	}
}
