package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.*;
import java.io.IOException;
import java.util.Vector;
import java.util.Hashtable;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.*;
import javax.sql.DataSource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class ValidateCharacteristicAction extends Action {
	
	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
  			
  			ActionErrors errors = new ActionErrors();
			HttpSession session = request.getSession();
			ValidateCharacteristicForm vform = (ValidateCharacteristicForm) form;
			Connection conn = null;
			String returnString = "none_broken";
			
			if(session.getAttribute("user") == null)
				mapping.findForward("not_logged_in");
			
			try {
   				Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       		conn = dataSource.getConnection();
				
				//When user clicks "Validate"-button
				if((vform != null) && (vform.getSubmit() != null) && (vform.getSubmit().equals("Validate"))) {
				
				
				
					RuleBean rules = new RuleBean();
					TaskBean task = (TaskBean) session.getAttribute("task");
					task.getCharacterisationsOfTaskFromDB(conn, errors);
					Vector fragments;
					RuleBean testRule = new RuleBean();
					Hashtable characterisation = task.getCharacterisation();
					
					rules.getAllRulesFromDB(conn, errors);	
					fragments = rules.getRules();
					
					int i = 0;
					int j = 0;
					Integer val;
					boolean ftest = false;
					boolean broken = false;
					while(i < fragments.size()) {
						testRule = (RuleBean)fragments.elementAt(i);
						
						if(!testRule.getRelation().equals("end")){
							if(testRule.getOperator().equals("ge")) {
								val = (Integer)characterisation.get(new Integer(testRule.getCharacteristicID()));
								if(val.intValue() >= testRule.getValue()) {
									ftest = true;
									}
							}
							if(testRule.getOperator().equals("eq")) {
								val = (Integer)characterisation.get(new Integer(testRule.getCharacteristicID()));
								if(val.intValue() == testRule.getValue()) {
									ftest = true;
									}
							}
							
						}
						
						if(testRule.getRelation().equals("end") && ftest) {
							if(testRule.getOperator().equals("ge")) {
								val = (Integer)characterisation.get(new Integer(testRule.getCharacteristicID()));
								if(val.intValue() < testRule.getValue()) {
									broken = true;
									}
							}
							if(testRule.getOperator().equals("eq")) {
								val = (Integer)characterisation.get(new Integer(testRule.getCharacteristicID()));
								if(val.intValue() != testRule.getValue()) {
									broken = true;
									}
									
							}
							if(broken) {
								vform.addBrokenRule(testRule.getName());
								vform.addBrokenRule(testRule.getWarning());
								for(int k = j; k <= i; k++)	{
									testRule = (RuleBean)fragments.elementAt(k);
									vform.addBrokenRule(testRule.getCharacteristic());
									vform.addBrokenRule(testRule.getOperator());
									vform.addBrokenRule(new Integer(testRule.getValue()));
									vform.addBrokenRule((Integer)characterisation.get(new Integer(testRule.getCharacteristicID())));
									vform.addBrokenRule(testRule.getRelation());
								}
								returnString = "broken";
								broken = false;
							}		
							j = i + 1;
							ftest = false;
						}
						if(testRule.getRelation().equals("end") && !ftest)
						j = i + 1;
						
						i++;
					}
					
					
  				}
  				
  				
  			} catch(Exception sqle) {
			   		servlet.log("Connection.process", sqle);
		   			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
    					servlet.log("Connection.close", e);
    					errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
    				}
    			}					
			}
			return mapping.findForward(returnString);
  		}
}