package com.mowahs.mwcf.site.actions;

import com.mowahs.mwcf.site.forms.*;
import com.mowahs.mwcf.framework.ScenarioBean;
import com.mowahs.mwcf.framework.UserBean;
import com.mowahs.mwcf.framework.GroupBean;
import com.mowahs.mwcf.framework.TaskBean;
import com.mowahs.mwcf.framework.IndicatorBean;
import com.mowahs.mwcf.framework.CharacteristicBean;
import java.util.Vector;
import java.io.IOException;
import java.math.BigDecimal;
import javax.naming.*;
import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;

public final class ViewCharacterisationAction extends Action {
  
  	public ActionForward perform(ActionMapping mapping, ActionForm form, 
  		HttpServletRequest request, HttpServletResponse response) 
  		throws IOException, ServletException {
			
			HttpSession session = request.getSession();
			ActionErrors errors = new ActionErrors();
			
			
			/**
			if(user == null) {
				try {
					session.invalidate();
					return mapping. findForward("not_logged_in");
				} catch (java.lang.IllegalStateException e) {
					//do nothing
				}
			}
			*/
			String returnString = "failure";
			String all = request.getParameter("all");
			String id = request.getParameter("scenarioId");
			String submit = request.getParameter("submit");
			String view = request.getParameter("view");
			String analysis = request.getParameter("analysis");
			
			
		
			
			//At first request, check if user is logged in. If logged in, prompt user for all or 
			// only own scenario, if not, show all scenarios in MWCF web system.
			if((session.getAttribute("user") != null) && (all == null) && (id == null) && (view == null) && (submit == null) && (analysis == null)) {
				return mapping.findForward("prompt");
			} else {
				
				Connection conn = null;
				try {
					
					Context ctx = new InitialContext();
      				if(ctx == null ) 
          				throw new Exception("No Context");
      				DataSource dataSource = (DataSource)ctx.lookup("java:comp/env/jdbc/mwcfDB");
	       			
	       			conn = dataSource.getConnection();
	       	
					
					// Show the indicator values for the scenario
					if(analysis != null) {
										
						ScenarioBean scenario = (ScenarioBean)session.getAttribute("scenario");
											
						if(scenario == null) {
							scenario = new ScenarioBean();
							int scenarioid = new Integer(analysis).intValue();
							scenario.getScenarioFromDB(conn, errors, scenarioid);
							scenario.getTasksInScenarioFromDB(conn, errors);	
						}
						CharacteristicBean charac = new CharacteristicBean();
						charac.getAllCharacteristicsFromDB(conn, errors);
						Vector characs = charac.getCharacteristics();
						for(int m=0; m<characs.size(); m++)
							((CharacteristicBean)characs.elementAt(m)).calculateScenarioAverage(conn, errors, scenario.getScenarioID());
						
						if(characs != null) {
							scenario.calculateScenarioComplexity(characs);	
							Vector tasks = scenario.getTasks();
							if(tasks == null || tasks.size()<1)
								errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("scenario.has.no.tasks"));
							else {
								IndicatorBean indicator = (IndicatorBean)session.getAttribute("indicator");
								if(indicator == null) {
									indicator = new IndicatorBean();
									indicator.getAllIndicatorsFromDB(conn, errors);
								}
								Vector indis = indicator.getIndicators();
								for(int i=0; i<indis.size(); i++) {
									IndicatorBean indi = (IndicatorBean) indis.elementAt(i);
									indi.calculateScenarioValues(conn, errors, tasks);
								}
								
								session.setAttribute("scenario", scenario);
								session.setAttribute("indicator", indicator);
							}
						} else
							errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("no.characteristics.exist"));
					
	   					if(errors.empty())
							return mapping.findForward("got_analysis");
						else {
							saveErrors(request, errors);
							returnString = "failure";
						}	
				
					//Show the characterisations and the computed averages of this scenario 
					} else if(view!=null) {
					
						ScenarioBean scenario = (ScenarioBean)session.getAttribute("scenario");
						if(scenario == null || scenario.getTasks() == null) {
							scenario = new ScenarioBean();
							int scenarioid = new Integer(view).intValue();
							scenario.getScenarioFromDB(conn, errors, scenarioid);
							scenario.getTasksInScenarioFromDB(conn, errors);
						}
						Vector tasks = scenario.getTasks();
						if(tasks == null || tasks.size()<1)
							errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("scenario.has.no.tasks"));
						else {
							scenario.calculateWeightAverage();
							GroupBean agroup = new GroupBean();
							agroup.getAllGroupsFromDB(conn, errors);							
													
							float tempSum = 0;
							int weightSum = 0;
							for(int i=0; i<tasks.size(); i++) {
								TaskBean task = (TaskBean)tasks.elementAt(i);
								task.calculateTaskAverage(conn, errors);
								tempSum = tempSum + task.getTaskAverage()*task.getWeight()*1000;
								weightSum = weightSum + task.getWeight();
							}
							if(tempSum > 0 && weightSum > 0)
								tempSum = tempSum/weightSum;
								
							BigDecimal bgtemp = new BigDecimal(tempSum);
	   						bgtemp = bgtemp.divide(new BigDecimal(1000), 2, BigDecimal.ROUND_HALF_UP);
							scenario.setScenarioAverage(bgtemp.floatValue());
							
							Vector allgroups = agroup.getGroups();
							for(int j=0; j<allgroups.size(); j++) {
								Vector characs = ((GroupBean)allgroups.elementAt(j)).getCharacteristics();
								for(int m=0; m<characs.size(); m++)
									((CharacteristicBean)characs.elementAt(m)).calculateScenarioAverage(conn, errors, scenario.getScenarioID());
							}
							session.setAttribute("group", agroup);
						}
						session.setAttribute("scenario", scenario);
			
						returnString = "got_characterisation";
												
									
					//If the user has chosen to see her own scenarios only, get the user's characterised scenarios
					} else if(all != null && all.equals("no")) { 
						UserBean user = (UserBean) session.getAttribute("user");
						if(user == null)
							return mapping.findForward("not_logged_in");
						ScenarioBean scenario = new ScenarioBean();
						int userid = user.getUserID();
						if(userid < 1)
							errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("please.login"));
						else {
							scenario.getAllCharacterisedFromDB(conn, errors, userid);
						}
						if(!errors.empty())
							saveErrors(request, errors);
						
						session.setAttribute("scenario", scenario);
						returnString = "got_scenarios";
				
					//If the user has chosen the scenario to view, get the characterised scenario and task details (not the characteristic values yet)
					} else if(id != null && (submit == null || !submit.equals("show"))) {
					
						int scenarioid = new Integer(id).intValue();
						ScenarioBean scenario = (ScenarioBean) session.getAttribute("scenario");
						if(scenario == null) {
							scenario = new ScenarioBean();
							session.setAttribute("scenario", scenario);
						}
						
						scenario.getScenarioFromDB(conn, errors, scenarioid);    	 	
		 				scenario.getRolesInScenarioFromDB(conn, errors);
		 				scenario.getTasksInScenarioFromDB(conn, errors);
		 				scenario.getCreatorFromDB(conn, errors);
						
	   					if(!errors.empty())
							saveErrors(request, errors);							
					
						returnString = "got_details";
				
							
					//The user is not logged in or has not chosen what to view a specific scenario, so the 
					//user should be shown a list of all scenarios.
					} else {
						ScenarioBean scenario = new ScenarioBean();
						scenario.setScenarios(new Vector());
						scenario.getAllCharacterisedFromDB(conn, errors);
						
						if(!errors.empty())
							saveErrors(request, errors);
						
						session.setAttribute("scenario", scenario);
						returnString = "got_scenarios";
					}
			
			
			} catch(Exception sqle) {
					System.out.println("*****----------********-------------************");
					sqle.printStackTrace();
		   			servlet.log("Connection.process", sqle);
	   				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.database"));
			} finally {
				if(conn != null){
					try {
						conn.close();
					} catch (SQLException e){
	    				servlet.log("Connection.close", e);
	    				errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("database.not.closed"));
	    			}
	    		}					
			}
			return mapping.findForward(returnString);			
        }
    }
}
