package com.mowahs.mwcf.site.forms;

import java.util.Vector;
import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;


public final class AddNewCharacteristicForm extends ActionForm {

	//The new characteristic's name
	private String name;
	//The new characteristic's description
	private String description;
	//The submit buttons value
	private String submit;
	//One of the values of the scale
	private int value;
	//One of the descriptions of the scale
	private String valueDescription;
	//The scale values and descriptions used for this characteristic.
	private Vector scale;
	
	
	public AddNewCharacteristicForm() {
		super();
		this.scale = new Vector();
	}
	
	//---- Setter and getter methods ------------------------
	
	public void setName(String nm) {
		this.name = nm;
	}
	
	public String getName() {
		return this.name;
	}

	public void setDescription(String desc) {
		this.description = desc;
	}
	
	public String getDescription() {
		return this.description;
	}
	
	public void setSubmit(String sub) {
		this.submit = sub;
	}
	
	public String getSubmit() {
		return this.submit;
	}
	
	public void setValue(int value) {
		this.value = value;
	}
	
	public int getValue() {
		return this.value;
	}
	
	public void setValueDescription(String valuedesc) {
		this.valueDescription = valuedesc;
	}
	
	public String getValueDescription() {
		return this.valueDescription;
	}		
	
	public void setScale(Vector valDes) {
		this.scale = valDes;
	}
	
	public Vector getScale() {
		return this.scale;
	}
	
	public void addToScale(Integer val) {
		this.scale.add(val);
	}
	
	public void addToScale(String desc) {
		this.scale.add(desc);	
	}
	
	//---- Validate form --------------------------------------
	
	public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
		ActionErrors errors = new ActionErrors();
		
		if(submit != null && submit.equals("Save characteristic") && (name == null || name.length() == 0))
			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("characteristic.name.required"));
		if(submit != null && submit.equals("Save characteristic") && (description == null || description.length() == 0))
			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("characteristic.description.required"));
		if(submit != null && submit.equals("Add value to scale") && (value == 0))
			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("scale.value.required"));
		if(submit != null && submit.equals("Add value to scale") && (valueDescription == null || valueDescription.length() == 0))
			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("scale.description.required"));
		
		return errors;
		
	}

	//---- Reset ------------------------------------------------
	/**
	 * Called by the framework to reset the fields back to their default values.
	 */
	//public void reset(ActionMapping mapping, HttpServletRequest request) 
		


}