package com.mowahs.mwcf.site.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public final class AddRoleForm extends ActionForm {

// --------------------------------------------------- Instance Variables

    /**
     * The name of the role.
     */
    private String newRole = null;

	private String submit = null;

    // ----------------------------------------------------------- Properties


    /**
     * Return the role name.
     */
    public String getNewRole() {

		return (this.newRole);

    }


    /**
     * Set the role name.
     *
     * @param newRole The name of the role
     */
    public void setNewRole(String newRole) {

        this.newRole = newRole;

    }
    
    public String getSubmit() {
    	
    	return (this.submit);
    }
    
    public void setSubmit(String submit) {
    	
    	this.submit = submit;
    	
    }

    // --------------------------------------------------------- Public Methods


    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {

        this.newRole = null;
        this.submit = null;
        
    }


    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {

   		ActionErrors errors = new ActionErrors();
        if ((newRole == null) || (newRole.length() < 1))
            errors.add("role", new ActionError("role", "Role name is required"));
        
        return errors;
   	}


}