package com.mowahs.mwcf.site.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import java.util.Vector;
import java.lang.reflect.Array;

public final class AddTaskForm extends ActionForm {

// --------------------------------------------------- Instance Variables

   	//The id of the task
   	private int taskID = -1;
   	
   	/**
     * The name of the task.
     */
    private String taskName = null;
   	
   	/**
     * The description of the task.
     */
    private String taskDescription = null;
    
     /**
     * The ID of the role responsible for the task.
     */
    private int responsible = -1;
    
    /**
     * The name of the role responsible for the task.
     */
    private String responsibleName = null;
        
    /**
     * The value of the submit button.
     */
	private String submit = null;
	
	/**
     * The step of the wizard
     */
	private int step = 1;
	
	/**
	 * The roles of the scenario
	 */
	private Vector roles = null;
    
  	/**
     * A location precondition of the task
     */
    private String preLocation = null;
   
   	/**
     * A resource precondition of the task
     */
    private String preResources = null;
    
    /**
     * The precondition tasks of the task
     */
    private int[] preTasks = null;
    
   
   	/**
     * A location postcondition of the task
     */
    private String postLocation = null;
   
   	/**
     * A resource postcondition of the task
     */
    private String postResources = null;
    
     /**
     * The postcondition tasks of the task
     */
    private int[] postTasks = null;
    
    
    /**
     * The dependency roles of the task
     */
    private int[] dependencyRoles = null;
    
    /**
     * The sub tasks of the task (tasks this task is composed of)
     */
    private int[] subTasks = null;
    
    
    /**
     * The composite property of a task
     */
	private String composite;
	
	/**
     * The task names that already exists in this scenario
     */
	private Vector existingTaskNames;
    
   
	// ----------------------------------------------------------- Constructor
	
	public AddTaskForm() {
				
	}
	

    // ----------------------------------------------------------- Properties

	/** 
	 * Get the task id
	 */
	public int getTaskID() {
		return this.taskID;
	}
	
	/**
	 * Set the task id
	 */
	public void setTaskID(int id) {
		this.taskID = id;
	}

    /**
     * Return the name of the task.
     */
    public String getTaskName() {
		return (this.taskName);
	}

	 
    /**
     * Set the name of the task.
     *
     * @param taskName The name of the task
     */
    public void setTaskName(String taskName) {
		this.taskName = taskName;
    }


    /**
     * Return the description of the task.
     */
    public String getTaskDescription() {
		return (this.taskDescription);
	}


    /**
     * Set the description of the task.
     *
     * @param taskDescription The description of the task
     */
    public void setTaskDescription(String taskDescription) {
		this.taskDescription = taskDescription;
    }

	
	/**
     * Return the ID of the responsible of the task.
     */
    public int getResponsible() {
		return (this.responsible);
    }

	/**
     * Set the responsible ID of the task.
     *
     * @param responsible The ID of the responsible of the task
     */
    public void setResponsible(int responsible) {
        this.responsible = responsible;
    }

/**
     * Return the name of the responsible of the task.
     */
    public String getResponsibleName() {
		return (this.responsibleName);
    }

	/**
     * Set the name of the responsible of the task.
     *
     * @param responsible The name of the responsible of the task
     */
    public void setResponsibleName(String responsibleName) {
        this.responsibleName = responsibleName;
    }
	
	/**
     * Return the Vector of roles.
     */
    public Vector getRoles() {
		return (this.roles);
    }


    /**
     * Set the roles.
     *
     * @param roles The Vector of roles of the scenarios.
     */
    public void setRoles(Vector roles) {
        this.roles = roles;
    }
	
    /**
     * Return any location precondition of the task.
     */
    public String getPreLocation() {
		return (this.preLocation);
    }


    /**
     * Set the location precondition of the task.
     *
     * @param preLocation The location precondition of the task
     */
    public void setPreLocation(String preLocation) {
        this.preLocation = preLocation;
    }
	
	
	 /**
     * Return any resource preconditions of the task.
     */
    public String getPreResources() {
		return (this.preResources);
    }

    /**
     * Set the resource preconditions of the task.
     *
     * @param preResources The resources precondition of the task
     */
    public void setPreResources(String preResources) {
        this.preResources = preResources;
    }
	
	
		
    /**
     * Return any location postcondition of the task.
     */
    public String getPostLocation() {
		return (this.postLocation);
    }


    /**
     * Set the location postcondition of the task.
     *
     * @param postLocation The location postcondition of the task
     */
    public void setPostLocation(String postLocation) {
        this.postLocation = postLocation;
    }
	
	
	/**
     * Return any resource postconditions of the task.
     */
    public String getPostResources() {
		return (this.postResources);
    }

    /**
     * Set the resource postconditions of the task.
     *
     * @param postResources The resources postcondition of the task
     */
    public void setPostResources(String postResources) {
        this.postResources = postResources;
    }
	
	
	
	/**
     * Set the roles the task has as dependencies.
     *
     * @param dependencyRoles The ids of the roles the task has as dependencies
     */
    public void setDependencyRoles(int[] dependencyRoles) {
        this.dependencyRoles = dependencyRoles;
    }
    	
	/**
     * Return any dependency roles of the task
     */
    public int[] getDependencyRoles() {
		return (this.dependencyRoles);
    }
	
	
	/**
     * Set the tasks the task has as preconditions
     *
     * @param preTasks The tasks the task has as preconditions
     */
    public void setPreTasks(int[] preTasks) {
        this.preTasks = preTasks;
    }
    	
	/**
     * Return any precondition tasks the task has
     */
    public int[] getPreTasks() {
		return (this.preTasks);
    }
		
	/**
     * Set the tasks the task has as postconditions
     *
     * @param postTasks The tasks the task has as postconditions
     */
    public void setPostTasks(int[] postTasks) {
        this.postTasks = postTasks;
    }
    	
	/**
     * Return any postcondition tasks the task has
     */
    public int[] getPostTasks() {
		return (this.postTasks);
    }
    
	/**
     * Return the composite attribute of the task.
     */
    public String getComposite() {
		return (this.composite);
    }

    /**
     * Set the resource postconditions of the task.
     *
     * @param postResources The resources postcondition of the task
     */
    public void setComposite(String composite) {
        this.composite = composite;
    }
	
		
	public String getSubmit() {
		return submit;
	}
	
	public void setSubmit(String submit){
		this.submit = submit;
	} 
	
	/**
     * Return the number of the wizard process
     */
    public int getStep() {
		return (this.step);
    }
    
     /**
     * Set the step of the wizard.
     *
     * @param step The step of the wizard of creating a scenario
     */
    public void setStep(int step) {
        this.step = step;
    }

	public void setExistingTaskNames(Vector existingTaskNames) {
		this.existingTaskNames = existingTaskNames;
	}
	
	public Vector getExistingTaskNames() {
		return this.existingTaskNames;
	}

	public void setSubTasks(int[] subs) {
		this.subTasks = subs;
	}
	
	public int[] getSubTasks() {
		return this.subTasks;
	}
    


    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
 	*/   
    public void doreset(ActionMapping mapping, HttpServletRequest request) {

       	this.taskName = null;
       	this.taskDescription = null;
       	this.preLocation = null;
       	this.preResources = null;
       	this.preTasks = null;
       	this.postLocation = null;
       	this.postResources = null;
       	this.postTasks = null;
       	this.composite = null;
       	this.submit = null;
       	this.step = 1;
       	this.responsibleName = null;
       	this.subTasks = null;
        
    }
 	

    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
		
   		ActionErrors errors = new ActionErrors();
        
        if(submit != null) {
           	if (submit.equals("Next") && ((this.taskName == null) || (this.taskName.length() < 1)))
        		errors.add("taskName.required", new ActionError("taskName.required"));
			
			if (submit.equals("Next") && (step == 3) && (this.postTasks != null) && (this.postTasks[0] != -1) && (this.preTasks != null) && (this.preTasks[0] != -1)) {
				for(int k=0; k<this.postTasks.length; k++) {
					for(int l=0; l<this.preTasks.length;l++) {
						if(postTasks[k] == preTasks[l])
							errors.add("pretask.posttask.cannot.match", new ActionError("pretask.posttask.cannot.match"));
					}
				}	
			}
			
	       	if (submit.equals("Next") && (step == 1) && (this.responsible == -1))
	    		errors.add("responsible.required", new ActionError("responsible.required"));
	    	if (submit.equals("Finish")) {
	    		for(int i=0; i<dependencyRoles.length; i++) {
	    			if(responsible == dependencyRoles[i])
	    				errors.add("role.not.responsible.and.dependency", new ActionError("role.not.responsible.and.dependency"));
	    		}
	    	}
	    	
	    }
        return errors;
        
   	}


}