package com.mowahs.mwcf.site.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

/**
 * This ActionForm is used to validate the 
 *
 */
public final class IndicatorForm extends ActionForm {

	//The indicator's name
	private String name = null;
	//The indicator's description
	private String description = null;
	//The submit buttons value
	private String submit = null;
	//The primary characteristics in the indicator
	private int[] primary = null;
	//The secondary characteristics in the indicator
	private int[] secondary = null;
	//The step of the wizard
	private String currentStep = "1";
	
	
	
	public IndicatorForm() {
		super();
	}
	
	//---- Setter and getter methods ------------------------
	
	public void setName(String nm) {
		this.name = nm;
	}
	
	public String getName() {
		return this.name;
	}

	public void setDescription(String desc) {
		this.description = desc;
	}

	public String getDescription() {
		return this.description;
	}
	
	public void setSubmit(String sub) {
		this.submit = sub;
	}
	
	public String getSubmit() {
		return this.submit;
	}
	
	public void setPrimary(int[] primary) {
		this.primary = primary;
	}
	
	public int[] getPrimary() {
		return this.primary;
	}
	
	public void setSecondary(int[] secondary) {
		this.secondary = secondary;
	}
	
	public int[] getSecondary() {
		return this.secondary;
	}
	
	public void setCurrentStep(String step) {
		this.currentStep = step;
	}
	
	public String getCurrentStep() {
		return this.currentStep;
	}
	
	
	
	//---- Validate form --------------------------------------
	
	public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
		
		ActionErrors errors = new ActionErrors();
		
		if(submit != null && submit.equals("Next") && currentStep.equals("two") && (name == null || name.length() == 0))
			errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("name.required"));

		return errors;
		
	}

	//---- Reset ------------------------------------------------
	/**
	 * Called by the controller to reset the fields back to their default values.
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
	
		this.name = null;
		this.description = null;
		this.submit = null;
		this.primary = null;
		this.secondary = null;
		this.currentStep = "1";	
		
	}
		


}