package com.mowahs.mwcf.site.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public final class LoginForm extends ActionForm {

// --------------------------------------------------- Instance Variables

    /**
     * The password.
     */
    private String password = null;


    /**
     * The email.
     */
    private String email = null;


	/**
	 * The submit button
	 */
	private String submit = null;
	
    // ----------------------------------------------------------- Properties


    /**
     * Return the password.
     */
    public String getPassword() {

	return (this.password);

    }


    /**
     * Set the password.
     *
     * @param password The new password
     */
    public void setPassword(String password) {

        this.password = password;

    }


    /**
     * Return the email.
     */
    public String getEmail() {

	return (this.email);

    }


    /**
     * Set the email.
     *
     * @param email The new email
     */
    public void setEmail(String email) {

        this.email = email;

    }

	/**
	 * Get the submit button
	 * @return The string of this submit button
	 */
	public String getSubmit() {
		return this.submit;
	}
	
	/**
	 * Set the submit button
	 * @param submit The content of this submit button
	 */
	 public void setSubmit(String submit) {
	 	this.submit = submit;
	}
	

    // --------------------------------------------------------- Public Methods


    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {

        this.password = null;
        this.email = null;
        this.submit = null;

    }


    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {

   		ActionErrors errors = new ActionErrors();
        if ((this.email == null) || (this.email.length() < 1))
            errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("email.required"));
        if (this.submit != null && this.submit.equals("Login") && ((this.password == null) || (this.password.length() < 1)))
            errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("password.required"));

        return errors;
   	}


}