package com.mowahs.mwcf.site.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public final class RegisterForm extends ActionForm {

	/**
     * The email.
     */
    private String email = null;

    /**
     * The name.
     */
    private String name = null;

    /**
     * The new password.
     */
    private String password = null;

	/**
     * The retyped new password.
     */
    private String password2 = null;

   
    /**
     * Return the new password.
     */
    public String getPassword() {
		return (this.password);
 	}

    /**
     * Set the new password.
     *
     * @param password1 The new password
     */
    public void setPassword(String password) {
        this.password = password;
    }

	/**
     * Return the retyped new password.
     */
    public String getPassword2() {
		return (this.password2);
	}

    /**
     * Set the retyped new password.
     *
     * @param password2 The retyped new password
     */
    public void setPassword2(String password2) {
        this.password2 = password2;
    }

    /**
     * Return the email.
     */
    public String getEmail() {
		return (this.email);
    }

    /**
     * Set the email.
     *
     * @param email The new email
     */
    public void setEmail(String email) {
        this.email = email;
    }
	
	 /**
     * Return the name.
     */
    public String getName() {
		return (this.name);
    }

    /**
     * Set the name.
     *
     * @param name The user's name
     */
    public void setName(String name) {
        this.name = name;
    }

    // --------------------------------------------------------- Public Methods


    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {

        this.email = null;
        this.name = null;
        this.password = null;
        this.password2 = null;
        

    }


    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {

   		ActionErrors errors = new ActionErrors();
        if ((this.email == null) || (this.email.length() < 1))
            errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("email.required"));
       	if ((this.password == null) || (this.password.length() < 1))
       		errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("password.required"));
       	else if (!this.password.equals(this.password2))
			errors.add("passwords.mismatch", new ActionError("passwords.mismatch"));
			
        return errors;
   	}


}