package com.mowahs.mwcf.site.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public final class UserAccountForm extends ActionForm {

// --------------------------------------------------- Instance Variables

    /**
     * The old password.
     */
    private String password = null;
    
    /**
     * The new password.
     */
    private String password1 = null;

	/**
     * The retyped new password.
     */
    private String password2 = null;

    /**
     * The email.
     */
    private String email = null;

    /**
     * The name.
     */
    private String name = null;
	
	/**
	 * The user's id
	 */
	private int userID = -1;
	
	/**
	 * The submit button's value
	 */
	private String submit = null;

	/**
	 * The access level of this user
	 */
	private String accessLevel = null;


    // ----------------------------------------------------------- Properties


    /**
     * Return the old password.
     */
    public String getPassword() {

	return (this.password);

    }


    /**
     * Set the old password.
     *
     * @param password The old password
     */
    public void setPassword(String password) {

        this.password = password;

    }
    
    /**
     * Return the new password.
     */
    public String getPassword1() {

	return (this.password1);

    }


    /**
     * Set the new password.
     *
     * @param password1 The new password
     */
    public void setPassword1(String password1) {

        this.password1 = password1;

    }

	/**
     * Return the retyped new password.
     */
    public String getPassword2() {

	return (this.password2);

    }


    /**
     * Set the retyped new password.
     *
     * @param password2 The retyped new password
     */
    public void setPassword2(String password2) {

        this.password2 = password2;

    }


    /**
     * Return the email.
     */
    public String getEmail() {

	return (this.email);

    }


    /**
     * Set the email.
     *
     * @param email The new email
     */
    public void setEmail(String email) {

        this.email = email;

    }
	
	 /**
     * Return the name.
     */
    public String getName() {

	return (this.name);

    }


    /**
     * Set the name.
     *
     * @param name The user's name
     */
    public void setName(String name) {

        this.name = name;

    }
    
    /**
     * Get the user's id
     * @return int The id of the user
     */
    public int getUserID() {
    	return this.userID;
    }
    
    /**
     * Set the user's id
     * @param id The int specifies the id of the user
     */
    public void setUserID(int id) {
    	this.userID = id;
    }

	/**
	 * Get the submit button's value
	 * @return java.lang.String The submit button's value
	 */
	public String getSubmit() {
		return this.submit;
	}
	
	/**
	 * Set the submit button's value
	 * @param submit The String value of the submit button
	 */
	public void setSubmit(String submit) {
		this.submit = submit;
	}

	/**
	 * Get the access level of this user
	 * @return Either (1) a - the administrator access level, or (2) u - the registered user access level.
  	 */
  	public String getAccessLevel() {
  		return this.accessLevel;
  	}
  	
  	/**
  	 * Set the access level of this user. Can be set to either 'a' (administrator) or 'u' (registered user)
  	 * @param access The access level of the user. Either 'a' or 'u'.
  	 */
  	public void setAccessLevel(String access) {
  		this.accessLevel = access;
  	}
  	 
  	 
    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {

        this.email = null;
        this.name = null;
        this.password = null;
        this.password1 = null;
        this.password2 = null;
        this.submit = null;
        this.userID = -1;
        this.accessLevel = null;

    }


    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {

   		ActionErrors errors = new ActionErrors();
   		if(submit != null && !submit.equals("Cancel")) {
	        if ((email == null) || (email.length() < 1))
	            errors.add("email.required", new ActionError("email.required"));
	       	if (((password == null) || (password.length() < 1)) && ((password1 == null) || (password1.length() < 1)))
	       		errors.add("password.required", new ActionError("password.required"));
	       	if (!password1.equals(password2))
				errors.add("passwords.mismatch", new ActionError("passwords.mismatch"));
			else if (password1 != null && password1.length() > 0)
				this.password = this.password1;
		}	
			
        return errors;
   	}


}